!     Last change:  ZK   22 Sep 2018    1:06 pm
!.. program originated by Z.K. at Univ. of Alaska
!.. tested and changed  by W.K.
!.. THERE ARE TWO LAYER FOR THE VISCOUS FLUID SUBAQUEOUS LANDSLIDE
!.. ALONG THE ONE HORIZONTAL DIMENSION

      PROGRAM SLIDE
      INCLUDE "block_2layer1d"
      Integer :: MaxM, MinM


!..  Note -- all units are in CGS (Set density = 1)
!..    --  +  --  + --  +      SPACE LOCATION OF SEA LEVEL AND VELOCITY
!..    U   Z  U   Z  U  Z
!..     J-1     J    J+1       GRID ENUMERATION

      CHARACTER*16 argm
      REAL    ::  HTOT

!.. Initializations 
      M=0
      CELL1 = 0
      CELL2=0

      SLMI=1000.
      SLMA=0.
      uo1=0; un1=0; SLO1=0; SLN1=0; D1=0
      uo2=0; un2=0; SLO2=0; SLN2=0; D2=0
      H1=0.; VELM=0.

      open(unit=15,file='lev1_20.dat',status='unknown')
      open(unit=16,file='vel1_20.dat',status='unknown')

      open(unit=18,file='LEV2_20.dat',status='unknown')
      open(unit=19,file='VEL2_20.dat',status='unknown')

      open(unit=20,file='VEL_TEMP.dat',status='unknown')

      CALL BEACH2()
     ! defines depth and   landslide as parabolic "hump"

      DO M=1, ME     !TIME LOOP
 

      !---------------------boundary_layer1-------------------
!.. LEFT BOUNDARY CONDITION IS FORCING WHEN AT THE LEFT
!.. SIDE THE SEA LEVEL IS GIVEN:

       CALL LEFT_radiating()
       CALL RIGHT_radiating()

 !     SLN1(JS)=SLO1(JS)

!--------------------depths----& Wet / dry cells---------
 
!..first in the lower layer (slide material)
        D2 = SLO2
        DO J=JS,JE
          IF (D2(J) .LT. EPSILON)THEN
            SLO2(J)= 0.
            D2(J)=0.
            CELL2(J)=0
          ELSE IF (SLO2(J) .GE. EPSILON) THEN
            CELL2(J)=1
          END IF
        END DO

!.. next in upper layer (water)
        DO j=js,je
          d1(j)=H1(j)+SLO1(j)-SLO2(J)
          IF (D1(J) .LT. EPSILON)THEN
            SLO1(J)=-H1(J)+SLO2(J)
            CELL1(J)=0
          ELSE IF (D1(J) .GE. EPSILON) THEN
            CELL1(J)=1
          END IF
        END DO

!..Runup 
!GO TO 21
        DO j = JS+1, JE - 1
          IF (CELL1(j) .EQ. 1 .AND. CELL1(J+1) .EQ. 0) then 
            if ((SLO1(j) + H1(j+1)-SLO2(J+1)) .GT. EPSILON) then    !flood cell on the right
              D1(J+1)= SLO1(j) + H1(j+1)-SLO2(J+1)
              CELL1(j+1) = 1
 !            SLO1(J+1) = SLO1(j)
              if (CELL1(J-1) .EQ. 1)THEN
                uo1(J+1)=uo1(J)
              else if (CELL1(J-1) .EQ. 0)THEN                       !special case if cell(j) is surrounded by empty cells
                uo1(J+1)=SQRT(G*D1(J+1)) ! DRY CELL1S
              end if
            end if
          END IF

          IF (CELL1(J-1) .EQ. 0 .AND. CELL1(J) .EQ. 1) THEN
            if ((SLO1(J) + H1(J-1)-SLO2(J-1)) .GT. EPSILON) then    !flood cell on the left
              D1(J-1)= SLO1(J) + H1(J-1)-SLO2(J-1)
              CELL1(J-1) = 1
   !          SLO1(J-1) = SLO1(J)        
              if (CELL1(J+1) .EQ. 1)THEN
                uo1(J)=uo1(J+1)
              else if (CELL1(J+1) .EQ. 0)THEN                       !special case if cell(j) is surrounded by empty cells
                uo1(J)=-SQRT(G*D1(J-1)) !BY DRY CELL1S
              end if
            end if
          END IF
        END DO
!GO TO 89

!.. Set velocity to zero at dry boundaries
        DO J=JS+1,JE-1
          IF (CELL1(J) .EQ. 0 .AND. CELL1(j-1) .EQ. 0)THEN
             uo1(J)=0.
           END IF
        END DO

        DO j = JS+1, JE-1        ! CHANGE 1  TO 2 FOR RADIATION
          IF (CELL1(j) .EQ. 1 .AND. CELL1(J+1) .EQ. 0) then
            if ((SLO1(j) + H1(j+1)-SLO2(J+1)) .LE. EPSILON) THEN    ! FOR THE BOun1DARY CONDITION U=0
              uo1(J+1)=0.                                           ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL1(J-1) .EQ. 0 .AND. CELL1(J) .EQ. 1) THEN
             if ((SLO1(j) + H1(j-1)-SLO2(J-1)) .LE. EPSILON) THEN   ! FOR THE BOun1DARY CONDITION U=0
              uo1(J)=0.                                             ! AT THE LEFT WALL
            end if
          END IF
        END DO
GO TO 89

        DO j = JS+1, JE-1
          IF (CELL1(j) .EQ. 1 .AND. CELL1(J+1) .EQ. 0) then
            if ((SLO1(j) + H1(j+1)) .LE. EPSILON) THEN               ! FOR THE BOun1DARY CONDITION U=0
              HTOT= H1(J)+SLO1(J)
              if (HTOT .Le. 0) HTOT=10.
              uo1(J+1)=  SLO1(J)/SQRT(HTOT/G)                        ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL1(J-1) .EQ. 0 .AND. CELL1(J) .EQ. 1) THEN
            if ((SLO1(j) + H1(j-1)) .LE. EPSILON) THEN    ! FOR THE BOun1DARY CONDITION U=0
              HTOT= H1(J)+SLO1(J)
              IF (HTOT .Le. 0) HTOT=10.
              uo1(J)= - SLO1(J)/SQRT(HTOT/G)
                                     ! AT THE LEFT WALL
            end if
          END IF
        END DO

   89 CONTINUE
!  21 CONTINUE

!.. this is just for quick orientation
        DO j=JS+1,je-1
          IF (SLO1(J) .GT. SLMA(j) .and. CELL1(J) .EQ. 1)THEN
            SLMA(j)=SLO1(J)
            MaxM = m
          END IF

          IF(uo1(j) .gt. VELM(j) .and. CELL1(J) .EQ. 1)THEN
            VELM(j)=uo1(J)
          END IF
        END DO
                                                            
 
!.. sea level distribution for the bottom generated tsun1ami
!     IF(M.EQ.MGEN)THEN
!     DO J=20000,40000
!   SLO1(J)=SLO1(J)+200.
!   END DO
!
!   END IF



! ONLY ONE SUBROUTINE FOR VELOCITY, BUT FOR BEACH4 IT HAS TO BE MODIFIED
! FOR RADIATION AT RIGHT END OFFSET DOMAIN
        CALL VELOCITY1()
        CALL VELOCITY2()

!       CALL BOTTOM_DEF()
!       IF(M==1)THEN    !This is because initial value is not zero
!         ETO=ETN
!       END IF


!..    >>>Update    SLO1   first<<<
!..  CONTINUITY

        CALL CONT2()
        CALL CONT1()

!.. Update VARIABLES to next time step
        SLO1=SLN1
        uo1=un1
        SLO2=SLN2
        uo2=un2

!.. write out data
        CALL WRITER_BEACH()

      END DO                  !END OF TIME LOOP


  303 continue
      DO j=JS,Je
        write (18,*) SLMA(J)
        write (19,*) VELM(J)
      END DO
  
      close(15)
      close(16)
      close(17)
      close(18)
      close(19)
      close(20) 


    CONTAINS


 
 ! BATHYMETRY - Gulf of Alaska Below
      SUBROUTINE BEACH1()   ! SLOPING SHORE LINE AS
      INTEGER::j

      DO J=98800,101200
        H1(J)=50.-50.*FLOAT(J-98800)/1200.      !UP TO -50.
      END DO

      DO J=97500,98799
        H1(J)=100.-50.*FLOAT(J-97500)/1299.     !TO 50M
      END DO

      DO J=95000, 97499
        H1(J)=200.-100.*FLOAT(J-95000)/2499.    !TO 100M
      END DO

      DO J=93000, 94999
        H1(J)=500.-300.*FLOAT(J-93000)/1999.    ! TO 200M
      END DO

      DO J=90500, 92999
        H1(J)=1000.-500.*FLOAT(J-90500)/2499.   !TO 500M
      END DO

      DO J=89700,90499
        H1(J)=2000.-1000.*FLOAT(J-89700)/799.   !TO 1000M
      END DO

      DO J= 87000, 89699
        H1(J)=3000.-1000.*FLOAT(J-87000)/2699.    !TO 2000M
      END DO

      DO J=1,86999
        H1(J )=3000.
      END DO

      OPEN(unit=17,file='depth_al.dat',status='unknown')
      DO j=js,Je
        WRITE(17,*)H1(J)
      END DO

      DO j=js,JE
        H1(J)=H1(J)*100.
      END DO
       
      DO j=js+1,je
        DHU(j)=(H1(j-1)+H1(J))*0.5
      END DO    ! DEPTH AT THE U POINTS

      DHU(JS)=DHU(JS+1)

      close(17)

      END SUBROUTINE



 
      SUBROUTINE BEACH2()
      REAL, DIMENSION(1:JE) :: H2
      INTEGER :: j, IND, JC, J1
      REAL :: HL, HR, HB, H20, L0, PAR

      OPEN (unit=11,file='depth.dat',status='unknown')
      HL=1.e4        ! depth at the left
    ! hr=3.5e4
      HR=6.E4
    ! hr=12500.              !depth on the right
      hb=(hr-hl)/float(jE)

!------parameters for the mud slide--------------

      H20=2500.       !initial thickness of the slide (D zero)
      L0=10000.       !initial length of the slide
      jc=500          !center of the slide

!--------------------------------------------------------------
      ind=INT(L0/(2.*Hx))
       
      H2 = 0.
      DO j=1,jE
        H1(j)=hl+hb*float(j)
      END DO
!     H1 = 10000. 

      DO j=js+1,je
        DHU(j)=(H1(j-1)+H1(J))*0.5
      END DO                         ! DEPTH AT THE U POINTS
      DHU(JS)=DHU(JS+1)

      DO j=jc-ind,jc+ind             ! set landslide as parabolic "hump"
        par=(2.*Hx*float(j-jc))/L0   ! with the maximum at jc
        H2(j)=H20*(1.-par*par)
    !   print*,j,H2(j)
        write(11, *)H2(j)
      END DO

      SLO2 = H2 
      close(11)

      END SUBROUTINE



 
!.. BOUNDARY CONDITIONS
      SUBROUTINE LEFT_FORCING()
      REAL    :: W, AM, DJS1

      W=2.*PI/TP
      AM=200.
      DJS1=H1(JS+1)+SLO1(JS)                                !
      SLO1(js)=am*sin(w*m*T)-uo1(JS+1)*SQRT(DJS1/G)
  !           SLO1(JS)=SLO1(JS)+(uo1(JS+1)-un1R)*SQRT(h(JS+1)/G)
      SLN1(JS)=SLO1(JS)

      END SUBROUTINE


      SUBROUTINE RIGHT_FORCING()
      REAL    :: W, AM

      W=2.*PI/TP
      AM=100.
      SLO1(jE)=am*sin(w*m*T) -uo1(JE)*SQRT(H1(JE)/g)
      SLN1(JE)=SLO1(JE)

      END SUBROUTINE


      SUBROUTINE LEFT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H1(js+1) +SLO1(js+1)
      IF( Dtmp .LT. 0. ) THEN
        Dtmp = 0.
      END IF
      SLO1(js) = -uo1(js+1)*SQRT(Dtmp/g)
      SLN1(js) = SLO1(js)

      END SUBROUTINE


      SUBROUTINE RIGHT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H1(JE-1) +SLO1(JE-1)
      IF ( Dtmp .LT. 0. ) THEN
        Dtmp = 0.
      END IF                     

      SLO1(JE)=uo1(JE)*SQRT(DTMP/G)
      SLN1(JE)=SLO1(JE)

      END SUBROUTINE



      SUBROUTINE BOTTOM_DEF()
      IF (M .LE. MGEN) then
        DO J=145000,155000
          ETN(J)=200.*FLOAT(M)/FLOAT(MGEN)  ! LINEAR CHANGE IN TIME
        END DO
      ELSE IF (M .GT. MGEN) THEN
        DO J=145000,155000
          ETN(J)=200.
        END DO
      END IF
   
      END SUBROUTINE




!.. continuity equation for layer 1
      SUBROUTINE CONT1()
      REAL, DIMENSION(1:JE) :: FLUX
      REAL :: ULP, ULN

      FLUX=0.

   !  CELL1(JS)=1
   !  CELL1(JS+1)=1
      DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
        IF (CELL1(J) .EQ. 1 .AND. CELL1(J-1) .EQ. 1)THEN          ! this computes the left wall volume flux
          ULP=0.5*(un1(J)+ABS(un1(J)))
          ULN=0.5*(un1(J)-ABS(un1(J)))
          FLUX(J)=  ULP*(SLO1(J-1)-SLO2(J-1))+ ULN*(SLO1(J)-SLO2(J)) &
        !   ULP*H1(J-1)+ULN*H1(J)                                    &
            +DHU(J)*un1(J)
        END IF
      END DO

      DO J = JS+1, JE-1
        SLN1(J)=SLO1(J)- (FLUX(J+1)-FLUX(J))*THX +TRANS2(J)   ! Note, "trans2" is from the second layer
      END DO

      END SUBROUTINE



!.. continuity equation for layer 2 (slide material)
      SUBROUTINE CONT2()
      REAL, DIMENSION(1:JE) :: FLUX
      REAL :: ULP, ULN, DFLUX

      FLUX=0.
   !  CELL1(JS)=1
   !  CELL1(JS+1)=1
      DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
        IF (CELL2(J) .EQ. 1 .AND. CELL2(J-1) .EQ. 1)THEN            ! this computes the left wall volume flux
          ULP=0.5*(un2(J)+ABS(un2(J)))
          ULN=0.5*(un2(J)-ABS(un2(J)))
          FLUX(J)=  ULP*SLO2(J-1)+ULN*SLO2(J)
       !         ULP*H1(J-1)+ULN*H1(J) &

        END IF
      END DO

      DO J = JS+1, JE-1
        DFLUX=  (FLUX(J+1)-FLUX(J))
        TRANS2(J)=  -DFLUX*THX                                       !THIS is DS2/DT IN UPPER LAYER CONTINUITY
        SLN2(J)=SLO2(J)- DFLUX*THX
      END DO

      END SUBROUTINE



!.. Velocity update for layer 1
      SUBROUTINE VELOCITY1()
      REAL, DIMENSION(1:JE) :: DU, un1N
      REAL, PARAMETER :: ALPHA =0.02
      REAL :: DIST, DDU, uo1P, uo1N, UPR

      un1N=0.

!.. Boundary cell at left end of domain
      DU(JS+1)=DHU(JS+1)+0.5*(SLO1(JS)+SLO1(JS+1)) &
               -0.5*(SLO2(JS)+SLO2(JS+1))
      IF (DU(JS+1) .LE. 5.) DU(JS+1)=5.
      un1(JS+1)=uo1(JS+1)-GTHX*(SLO1(JS+1)-SLO1(JS))-r*T*uo1(JS+1)*abs(uo1(JS+1))/du(JS+1)
      un1n(js+1)=un1(JS+1)

!.. ENTIRE DOMAIN
      DO j = JS+2, JE-1
        IF (CELL1(J-1) .EQ. 1 .AND. CELL1(J) .EQ. 1) then
          DU(J)=DHU(J)+0.5*(SLO1(J-1)+SLO1(J))-0.5*(SLO2(J-1)+SLO2(J))
          DDU=DU(J)
          if (DU(J) .LE. 5.) DDU=5.   ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION

          uo1P=0.5*(uo1(j)+ABS(uo1(j)))
          uo1N=0.5*(uo1(J)-ABS(uo1(J)))
          UPR=UO1(J)-UO2(J)           ! Used for computation of iterface stress

          un1(j)=uo1(J) &
             -THX*(uo1P*(uo1(J)-uo1(J-1))+uo1N*(uo1(J+1)-uo1(J))) &
             + GTHX*(SLO1(j-1) - SLO1(j)) &
             -r1*T*UPR*abs(UPR)/DDU
        END IF
      END DO

!.. Boundary cell at right end of domain
      un1(JE)=uo1(JE)-GTHX*(SLO1(JE)-SLO1(JE-1)) &
       -r*T*uo1(JE)*abs(uo1(JE))/du(JE-1)
      un1N=un1  ! JUST FOR FILTERING


!.. CHECK   ! FILTER IF NEEDED
      DO j = JS+2, JE-1
        un1(J)=un1N(J)*(1.-ALPHA)+0.25*ALPHA*(un1N(J-1)+2.*un1N(J)+un1N(J+1))
      END DO
                                                                          
      DO J=JS+2,JE-1  ! THIS IS ONLY BEAUTIFICATION (but good one)
        IF (CELL1(j) .EQ. 0 .AND. CELL1(j-1) .EQ. 0)THEN
          un1(J)=0.
       !  if ((D(J-1)+D(J)).LE.0.)un1(J)=0.
        END IF
      END DO

      DO j = JS+1, JE-1
        IF (CELL1(j) .EQ. 1 .AND. CELL1(J+1) .EQ. 0) then
          if ((SLO1(j) + H1(j+1)) .LE. 0.) THEN    ! FOR THE BOun1DARY CONDITION U=0
            un1(J+1)=0.                            ! AT THE RIGHT WALL
          end if
        END IF

        IF (CELL1(J-1) .EQ. 0 .AND. CELL1(J) .EQ. 1) THEN
          if ((SLO1(j) + H1(j-1)) .LE. 0.) THEN    ! FOR THE BOun1DARY CONDITION U=0
            un1(J)=0.                      ! AT THE LEFT WALL
          end if
        END IF
      END DO

      END SUBROUTINE



!.. velocity update for layer 2
      SUBROUTINE VELOCITY2()
      REAL, DIMENSION(1:JE) :: DU, un2N, LPTEM, LMTEM
      REAL, PARAMETER :: ALPHA =0.02
      REAL :: DIST, DDU, uo2P, uo2N, DSLO1, UPR

      un2N=0.

!.. ENTIRE DOMAIN

      DO j = JS+1, JE-1
        IF (CELL2(J-1) .EQ. 1 .AND. CELL2(J) .EQ. 1) then
          DU(J)=0.5*(SLO2(J-1)+SLO2(J))
          DDU=DU(J)
          if (DU(J) .LE. 5.) DDU=5. ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION
          uo2P=0.5*(uo2(j)+ABS(uo2(j)))
          uo2N=0.5*(uo2(J)-ABS(uo2(J)))
          DSLO1= SLO1(j-1) - SLO1(j)
          UPR=UO1(J)-UO2(J)
          un2(j)=uo2(J)  &
            -THX*(uo2P*(uo2(J)-uo2(J-1))+uo2N*(uo2(J+1)-uo2(J))) &
            + GTHX*DSLO1                                         &
            + GTHXDD*(SLO2(j-1) - SLO2(j)+H1(J)-H1(J-1)-dslo1)   &
            +R1*T*UPR*ABS(UPR)/(RHO2*DDU)                        &
            -r*T*uo2(j)*abs(uo2(j))/(RHO2*DDU)
        END IF
      END DO
 
      DO j = JS+2, JE-1
        IF (CELL2(J-1) .EQ. 0 .AND. CELL2(J) .EQ. 0) UN2(J)=0.
      END DO

!.. EXTRAPOLATION  FOR THE LANDSLIDE MOTION
  !.. left end
      DO j = JS+1, JE-1
        IF (CELL2(J-1) .EQ. 0 .AND. CELL2(J) .EQ. 1 .AND. CELL2(J+1) .EQ. 1) then
          if (UN2(J+1) .LE. 0)THEN
            LMTEM(J)=LMTEM(J)+T*ABS(UN2(J+1))
            if (LMTEM(J) .GE. HX)THEN
              UN2(J)=UN2(J+1)
              CELL2(J-1)=1
              LMTEM(J)=0.
            end if
          end if
          if (UN2(J+1) .GT. 0) UN2(J)=UN2(J+1)
        END IF
      END DO

  !.. Right end
      DO j = JE-1, JS +2,-1
        IF (CELL2(J-1) .EQ. 1 .AND. CELL2(J) .EQ. 0) then
          if (UN2(J-1) .LT. 0) UN2(J)=0.
          if (UN2(J-1).GT.0)THEN
            LPTEM(J)=LPTEM(J)+UN2(J-1)*T
            if (LPTEM(J) .GE. HX)THEN
              UN2(J)=UN2(J-1)
              CELL2(J)=1
              LPTEM(J)=0.
       !      slo2(j)=slo2(j-1)/2
       !      slo2(j-1)=slo2(j)
            end if
          end if
        END IF
      END DO

!.. CHECK   ! FILTER IF NEEDED
      un2n=un2
      DO j = JS+2, JE-2
        IF (CELL2(J-1) .EQ. 1 .AND. CELL2(J) .EQ. 1 .AND. CELL2(J+1) .EQ. 1) then
          un2(J)=un2N(J)*(1.-ALPHA)+0.25*ALPHA*(un2N(J-1)+2.*un2N(J)+un2N(J+1))
        END IF
      END DO

      END SUBROUTINE


 
      SUBROUTINE WRITER_BEACH()
      REAL::  SMAXW, SUM1
      INTEGER :: JLOC

      SMAXW=0.
      IF (mod(m,100) .eq. 0)then
        PRINT*, SLO2(500),"TIME STEP=",M
        DO J=450,550,2
          WRITE(20,*)UO2(J),SLO2(J),J
        END DO
        WRITE(20,*)"TIME STEP=",M
!       SUM1=0
!       DO J=JS,JE
!         SUM1=SUM1+SLO2(J)
!       END DO
!       PRINT*,"SUMBOTTOM=",SUM1
!       DO J=JS,JE
!         IF(SLO1(J).GT.SMAXW.AND.CELL1(J).EQ.1)THEN
!           SMAXW=SLO1(J)
!           JLOC=J
!         END IF
!       END DO



!       PRINT*,"MAXVALUE= ", SMAXW," LOCATOR=",JLOC ," TIME STEP= ",M
!       PRINT*,"MAX_LOCATION= ", MAXLOC(SLO1,CELL1.eq.1)

        DO j=JS,Je
          write (15,*) SLO1(J)
          write (16,*) uo1(J)

          write (18,*) SLO2(J)
          write (19,*) uo2(J)

        END DO
      END IF
      end subroutine

   END PROGRAM   SLIDE
