!     Last change:  ZK   31 Oct 2018   11:26 am
!..     Last change:  ZK    4 Oct 2009    4:28 pm
!..  program originated by    W.K. and Z.K. at Univ. of Alaska

      PROGRAM slosh
      INCLUDE "block_2layer2d"
 
!..       Note -- all units are in CGS (Set density = 1)

!..          V  |    V |  V  |
!..   K+1
!..         --  +  --  + --  +      SPACE LOCATION OF SEA LEVEL AND VELOCITY
!..         U   Z  U   Z  U  Z
!..          J-1     J    J+1       GRID ENUMERATION
!..          V  |    V |  V  |
!..   K
!..         --  +  --  + --  +      SPACE LOCATION OF SEA LEVEL AND VELOCITY
!..         U   Z  U   Z  U  Z
!..          J-1     J    J+1       GRID ENUMERATION

      INTEGER,PARAMETER :: IS=2
      integer,dimension(IS) :: NUMS, JMS, KMS
      INTEGER :: UNITS, i
      REAL :: HTL, Htot, HTR, SLD, SLU
      REAL,DIMENSION(IS) :: LONGS, LATS, ZSU
      CHARACTER*14,DIMENSION(IS)::SNAME
      CHARACTER*16 argm, NAMEs

!.. Initializations
      ZSU=0.
      DHU=0.; DHV=0.
      M=0; IC=0; KK=0
      CELL1=0; CELL1X=0
      CELL2=0

      VO1 = 0.0; VN1=0.; SLNN=0.
      VO2 = 0.0; VN2=0.

      UO1=0.; UN1=0.; SLO1=0.; SLN1=0.; D1=0.; H1=0.
      VO1=0.; VN1=0.
      Uo2=0; un2=0; SLO2=0; SLN2=0; D2=0
      VO2=0.; VN2=0.
      LPTEMY = 0.; LMTEMY = 0.
      LPTEMX = 0.; LMTEMX = 0.; LMTEMXY = 0.
      ZINP=0.
      SLMA=0.
      TRANSX=0.
      TRANSY=0.
      JM=0; KM=0
      ZMAX=-1.
 
!     argm= 'BEACH2'

      open(unit=14,file='long1u.dat',status='unknown')
      open(unit=15,file='long1.dat',status='unknown')
      !  open(unit=16,file='surface.dat',status='unknown')
      open(unit=16,file='surface1.dat',form='unformatted',status='unknown')

      ! open(unit=17,file='u.dat',status='unknown')
      open(unit=17,file='u.dat',form='unformatted',status='unknown')

      !  open(unit=18,file='v.dat',status='unknown')
      open(unit=18,file='v.dat',form='unformatted',status='unknown')

      !  open(unit=19,file='uen.dat',status='unknown')
      open(unit=19,file='uen.dat',form='unformatted',status='unknown')

     !   open(unit=20,file='ven.dat',status='unknown')
      open(unit=20,file='ven.dat',form='unformatted',status='unknown')
      open(unit=22,file='surface2.dat',form='unformatted',status='unknown')
      open(unit=23,file='U2.dat',form='unformatted',status='unknown')

      open(unit=24,file='V2.dat',form='unformatted',status='unknown')


!..FILES FOR RECORDING TIME VARIABILITY
!IS=28
      open(unit=30,file='station_aleutian.dat',status='unknown')
      DO I=1,IS
        READ(30,*) NUMS(I), Jms(I), KMS(I), LONGS(I), LATS(I), SNAME(I)
      END DO
      close(30)
!     PRINT*,SNAME(1),JMS(1),SNAME(28),KMS(28)
 
      DO I=1,IS
        UNITS=100+i
        WRITE(names,'(A7,I2.2,A4)')'station',i,'.dat'
        open(UNIT=uniTS,file=names,status='unknown')
      END DO

 
! INITIAL TIME STEPPING
 
!.. ESTABLISH DEPTH AND SEA LEVEL 
      CALL TRIGON()
      CALL BEACH2()
      DO I=1, IS
        UNITS=100+i
        open(UNITS)
        WRITE(UNITS,*)NUMS(I), Jms(I), KMS(I), LONGS(I), LATS(I), SNAME(I), H1(JMS(I), KMS(I))
      END DO
!     GO TO 203
 
      DO M=1, ME    !TIME LOOP
        IF (MOD(m, 10) .EQ. 0) THEN
         print*,"M=",  m
         print*, 100.*float(m)/float(me), " percent done"
        END IF

!       SELECT CASE (argm)
!       CASE('BEACH4')

        CALL NORTH_RADIATING()
        CALL SOUTH_RADIATING()
        CALL RIGHT_RADIATING()
        CALL LEFT_RADIATING()


 !      CALL RIGHT_FORCING()

 !      CASE DEFAULT
 !      END SELECT
 !      SLO(js)=am*sin(w*m*T)
 !      SLN1(JS)=SLO(JS)

!.. ESTABLISH WET-DRY  CELLS------------- 
 !..first consider the lower layer
        D2 = SLO2
        DO J=JS, JE
          DO K=KS, KE
            IF (D2(J, K) .LT. EPSILON) THEN
              SLO2(J, K)= 0.
              D2(J, K) = 0.
              CELL2(J, K)=0    
            ELSE
              CELL2(J, K)=1
            END IF
          END DO
        END DO

        D1 = H1+SLO1-SLO2
        DO j=js, je
          DO K=KS, KE
            IF (D1(J, K) .LT. EPSILON)THEN
              SLO1(J, K)=-H1(J, K)+SLO2(J, K)
              CELL1(J, K)=0
            ELSE
              CELL1(J, K)=1
            END IF
          END DO
        END DO

!.. RUNUP ALONG X DIRECTION
        CELL1X=0    !TEMPORARY VALUE IF NEW CELL1 IS GENERATED IN THE RUNUP PROCESS
                    !ALONG X DIRECTION IT IS NOT USED FOR THE RUNUP ALONG Y. ONLY OLD CELLS
                    ! ARE USED IN THE PROCESS.
        DO K=1,KE
          DO j = JS+1, JE-1
            IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
              if ((SLO1(J, K) + H1(J+1, K)-SLO2(j+1, K)) .GT. epsilon) then
                D1(J+1, K)= SLO1(J, K) + H1(J+1, K)-SLO2(J+1, K)
                CELL1(J+1, K) = 1
                CELL1X(J+1, K) = 1
 !              SLO1(J+1, K) = SLO1(J, K)         !
                if (CELL1(J-1, K) .EQ. 1) THEN
                  UO1(J+1, K)=UO1(J, K)
                end if
                if (CELL1(J-1, K) .EQ. 0) THEN     ! CELL11 (J,K) IS SURROUNDED BY
                  UO1(J+1, K)=SQRT(G*D1(J+1, K))   ! DRY CELL1S
                end if
              end if
            END IF

            IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
              if ((SLO1(J, K)+H1(J-1, K)-SLO2(J-1, K)) .GT. EPSILON) then
                D1(J-1, K)= SLO1(J, K) + H1(J-1, K)-SLO2(J-1, K)
                CELL1(J-1, K) = 1
                CELL1X(J-1, K) = 1
 !              SLO1(J-1, K) = SLO1(J, K)          !
                if (CELL1(J+1, K) .EQ. 1)THEN
                  UO1(J, K)=UO1(J+1, K)
                end if
                if (CELL1(J+1, K) .EQ. 0)THEN      !CELL1(J,K) SURROUNDER BY DRY CELL1S
                  UO1(J, K)=-SQRT(G*D1(J-1, K))
                end if
              end if
            END IF
          END DO
        END DO

!.. RUNUP ALONG Y DIRECTION
        DO J=1, JE
          DO K = KS+1, KE-1
            IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
              if ((SLO1(J, K)+H1(J, K+1)-SLO2(J, K+1)) .GT. EPSILON .AND. CELL1X(J, K) .EQ. 0) then
                D1(J, K+1)= SLO1(J, K) + H1(J, K+1)-SLO2(J, K+1)
                CELL1(J, K+1) = 1
!               SLO1(J, K+1) = SLO1(J, K)
                if (CELL1(J, K-1) .EQ. 1)THEN
                  VO1(J, K)=VO1(J, K-1)
                end if
                if (CELL1(J, K-1) .EQ. 0) THEN
                  VO1(J, K)=SQRT(G*D1(J, K+1))
                end if
              end if
            END IF

            IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
              if ((SLO1(J, K)+H1(J, K-1)-SLO2(J, K-1)) .GT. EPSILON .AND. CELL1X(J, K) .EQ. 0) then
                D1(J, K-1)= SLO1(J, K) + H1(J, K-1)-SLO2(J, K-1)
                CELL1(J, K-1) = 1
 !              SLO1(J, K-1) = SLO1(J, K)
                if (CELL1(J, K+1) .EQ. 1) THEN
                  VO1(J, K-1)=VO1(J, K)
                end if
                if (CELL1(J, K+1) .EQ. 0) THEN
                  VO1(J, K-1)=-SQRT(G*D1(J, K-1))
                end if
              end if
            END IF
          END DO
        END DO


!.. SETTING VELOCITY ALONG X
        DO K=KS+1,KE-1
          DO J=JS+1,JE-1
            IF (CELL1(J, K) .EQ. 0 .AND. CELL1(j-1, K) .EQ. 0) THEN
              UO1(J, K)=0.
            END IF
          END DO

          DO j = JS+1, JE-1        ! CHANGE 1  TO 2 FOR RADIATION
            IF (CELL1(j, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
              if ((SLO1(j, K)+H1(j+1, K)-SLO2(J+1, K)) .LE. EPSILON) THEN ! FOR THE BOUNDARY CONDITION U=0
                UO1(J+1, K)=0.                                            ! AT THE RIGHT WALL
              end if
            END IF

            IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
              if ((SLO1(j, K)+H1(j-1, K)-SLO2(J-1, K)) .LE. EPSILON) THEN ! FOR THE BOUNDARY CONDITION U=0
                UO1(J,K)=0.                                               ! AT THE LEFT WALL
              end if
            END IF
          END DO
GO TO 89

          DO j = JS+1, JE-1
            IF (CELL1(j, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
              if ((SLO1(j, K)+H1(j+1, K)-SLO2(J+1, K)) .LE. EPSILON) THEN  ! FOR THE BOUNDARY CONDITION U=0
                HTOT= H1(J, K)+SLO1(J, K)-SLO2(J+1, K)
                if (HTOT .Le. 10.) HTOT=10.
                UO1(J+1,K)=  SLO1(J, K)/SQRT(HTOT/G)                       ! AT THE RIGHT WALL
              end if
            END IF

            IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
              if ((SLO1(j,  K)+H1(j-1, K)-SLO2(J-1, K)).LE.EPSILON) THEN   ! FOR THE BOUNDARY CONDITION U=0
                HTOT= H1(J, K)+SLO1(J, K)-SLO2(J-1, K)
                if (HTOT .Le. 10.) HTOT=10.
                UO1(J, K) = -SLO1(J, K)/SQRT(HTOT/G)                       ! AT THE LEFT WALL
              end if
            END IF
          END DO
        END DO

        DO K=1, KE 
          DO j = JS+1, JE-1
            IF (CELL1(J-1, K) .EQ. 1 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
              if ((SLO1(J, K) + H1(J+1, K)-SLO2(J+1, K)) .GT. epsilon) then
                UO1(J+1, K)=UO1(J, K)-SLO2(J+1, K)
              end if
            END IF
            IF (CELL1(J-1 ,K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 1) THEN
              if ((SLO1(J, K) + H1(J-1, K)-SLO2(J-1, K)) .GT. EPSILON) then
                UO1(J, K)=UO1(J+1, K)
              end if
            END IF

!.. Stranded fluid cell - surrounded by dry cells
            IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) THEN
              HTL= SLO1(J, K)+H1(J-1, K)-SLO2(J-1, K)
              HTR= SLO1(J, K)+H1(J+1, K)-SLO2(J+1, K)
              if ((SLO1(J, K) + H1(J-1, K)-SLO2(J-1, K)) .GT. EPSILON) then
                UO1(J, K) = -SQRT(G*HTL)
              end if
              if ((SLO1(J, K) + H1(J+1, K)-SLO2(J+1, K)) .GT. EPSILON) THEN
                UO1(J+1, K)=SQRT(G*HTR)
              end if
            END IF
          END DO
        END DO

 89 continue

!.. Setting velocity along Y
        DO J=JS,JE-1
          DO K=KS+1,KE-1
            IF (CELL1(J, K) .EQ. 0 .AND. CELL1(J, K+1) .EQ. 0) THEN
              VO1(J, K)=0.
            END IF
          END DO
          DO K = KS+1, KE-1
            IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
              if ((SLO1(J, K) + H1(J, K+1)-SLO2(J, K+1)) .LE. EPSILON) THEN   ! FOR BOUNDARY CONDITION V=0
                                                                              ! AT THE RIGHT WALL
                VO1(J,K)=0.
              end if
            END IF

            IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
              if ((SLO1(J, K) + H1(J, K-1)-SLO2(J, K-1)) .LE. EPSILON) THEN   ! FOR BOUNDAry CONDITION V=0
                VO1(J,K-1)=0.                                                 ! AT THE LEFT WALL
              end if
            END IF
          END DO
        END DO

 GO TO 88

        DO J=JS,JE-1
          DO K = KS+1, KE - 1
            IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
              if ((SLO1(J, K) + H1(J, K+1)-SLO2(J, K+1)) .LE. EPSILON) THEN  ! FOR BOUNDARY CONDITION V=0
                HTOT= H1(J,K)+SLO1(J,K)-SLO2(J,K)
                if (HTOT .Le. 10.) HTOT=10.  
                VO1(J, K)=SLO1(J, K)/SQRT(HTOT/G)                            ! AT THE NORTH WALL
              end if
            END IF

            IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J,K) .EQ. 1) THEN
              if ((SLO1(J, K) + H1(J, K-1)-SLO2(J, K-1)).LE.EPSILON) THEN    ! FOR BOUNDARY CONDITION V=0
                HTOT= H1(J, K)+SLO1(J, K)-SLO2(J, K)
                if (HTOT .Le. 10.)HTOT=10.
                VO1(J, K-1)= -SLO1(J, K)/SQRT(HTOT/G)                        ! AT THE SOUTH WALL
              end if
            END IF
          END DO
        END DO

        DO J=1,JE-1
          DO K = KS+1, KE-1
            IF (CELL1(J, K-1) .EQ. 1 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
              if ((SLO1(J, K) + H1(J, K+1)-SLO2(J, K+1)) .GT. EPSILON) then
                VO1(J, K)=VO1(J, K-1)
              end if
            END IF
            IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 1) THEN
              if ((SLO1(J,K) + H1(J, K-1)-SLO2(J, K-1)) .GT. EPSILON) then
                VO1(J, K-1)=VO1(J, K)
              end if
            END IF

 ! LONELY WET CELL1s
            IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1).EQ.0) THEN
              SLD= SLO1(J, K) + H1(J, K-1)-SLO2(J, K-1)
              SLU=SLO1(J, K) + H1(J, K+1)-SLO2(J, k+1)
              if  ((SLO1(J, K) + H1(J, K-1)-SLO2(J, K-1)) .GT. EPSILON) then
                VO1(J, K-1)=-SQRT(G*SLD)
              end if
              if ((SLO1(J, K) + H1(J, K+1)-SLO2(J, K+1)) .GT. EPSILON) then
                VO1(J, K)=SQRT(G*SLU)
              end if
            END IF
          END DO
        END DO
88 continue

!       IF(M .LE. LTIME)THEN
!         DO J=JS,JE
!           VO1(J,KE)=0.
!         END DO
!       END IF

!.. ONLY ONE SUBROUTINE FOR VELOCITY, BUT FOR BEACH4 IT HAS TO BE MODIFIED
!.. FOR RADIATION AT RIGHT END OFFSET DOMAIN
        CALL VELOCITY1X()
        CALL VELOCITY1Y()
        CALL VELOCITY2X()
        CALL VELOCITY2Y()
 
        CALL CONT2X()
        CALL CONT2Y()
 
 
        CALL CONT1X()
        CALL CONT1Y()

 !--------wet or dry?----------------------------
!.. Advance to next time step
        SLO1=SLN1
        UO1=UN1
        VO1=VN1

        SLO2=SLN2
        UO2=UN2
        VO2=VN2


!.. MY WRITING TO THE FILE
! IF(M.GT.MGEN)THEN
       ! CALL WRITER_BEACH()
! END IF
        DO J=1, JE
          DO K=1, KE
            IF (ABS(SLO1(J, K)) .GT. 80000 .AND. CELL1(J, K) .EQ. 1)THEN
              PRINT*, J,K, SLO1(J,K)
!    GO TO  203
            END IF
          END DO
        END DO

! JUST FOR QUICK ORIENTATION
        DO k=KS, KE
          DO j=JS, JE
            IF (SLO1(J, K) .GT. ZMAX(J, K) .and. CELL1(J, K) .EQ. 1)THEN
              ZMAX(J, K)=SLO1(J, K)
            END IF
            IF (ZMAX(J, K) .GT. SLMA)THEN
              SLMA=ZMAX(J, K)
              JM=J
              KM=K
            END IF
          END DO
        END DO

!       CALL WRITER_BENCH



      END  DO ! END TIME LOOP
      CALL WRITER_MAX()

 203  CONTINUE

      PRINT*,'SLMAX=',SLMA,'JMAX=',JM, 'KMAX=',KM
      PRINT*, "DONE"

      close(14); close(15); close(16); close(17); close(18)
      close(19); close(20); close(22); close(23); close(24)

      DO I=1,IS
        UNITS=100+i
        close(UNITS)
      END DO

    CONTAINS
 

      SUBROUTINE BEACH2
      REAL, DIMENSION(1:JE,1:KE) :: H2
      INTEGER :: j, INDY, JC, J1, KC, INDX
      REAL:: HL, HR, HB, H20, L0X, LOY, PARX, PARY, L0, HXC

      OPEN (unit=11,file='depth.dat',status='unknown')
    ! OPEN(unit=11,file='depth.dat',form='unformatted',status='unknown')

      hl=1.e4        ! depth at the left
    ! hr=3.5e4
      HR=6.E+4
    ! hr=12500.              !depth on the right
      hb=(hr-hl)/float(jE)
   
      H2 = 0.

      DO j=1,jE
        H1(j, 1:ke)=hl+hb*float(j)
      END DO
 

!.. depth at "u" point
      DO j=js+1,je
        DO K=1,KE
          DHU(J, K)=(H1(J-1, K)+H1(J, K))*0.5
        END DO
      END DO
      DO K=1,KE
        DHU(1, K) = DHU(2, K)
      END DO

!.. depth at "v" points
      DO J=1,JE
        DO K=Ks,KE-1
          DHV(J, K)=(H1(J, K+1)+H1(J, K))*0.5
        END DO
      END DO

      DO J=1,JE
        DHV(J,KE)=DHV(J,KE-1)
      END DO                                        

!------parameters for the mud slide--------------

      H20=2500.       !initial thickness of the slide (D zero)
      L0=10000.       !initial length of the slide
      jc=   500
      KC= 1000
 
!--------------------------------------------------------------
      HXC= HX*CSZ(KC)
      indX=INT(L0/(2.*HxC))     ! ONLY AT THE CENTER
      indY=INT(L0/(2.*HY))      ! ONLY AT THE CENTER

      DO  j=jc-indX,jc+indX     ! set landslide as parabola
        DO K=KC-INDY,KC+INDY
          PARY=(2.*HY*FLOAT(K-KC))/L0
          parX=(2.*HxC*float(j-jc))/L0 ! with the maximum at jc
          H2(j, K)=H20*(1.-parX*parX-PARY*PARY)

    !     print*,j,H2(j)
          IF (H2(J, K) .LT. 0) H2(J, K)=0.
        END DO
      END DO
 

      DO K=1,KE,100
        write (11,*) (H1(J, K),J=1,JE,100)
      END DO

      DO K=1,KE
        DO J=JS,JE
          SLO2(J, K)=H2(J, K)
        END DO
      END DO

      close(11)

      END SUBROUTINE




      SUBROUTINE TRIGON()
      REAL :: A1, A2, BLAT, HALF, RLAT, HXC

!.. calculate LATITUDE AND COS SIN  (LATITUDE NEGATIVE IN SOUTHERN HEMISPHERE)
!     RAD=  0.0174532930056254
!     HALF=0.5  ! HALF STEP ALONG Y IN DEGREE
!     DF=1./15.  ! IT IS EXPRESSED IN DEGREE
!     1MIN=1./60.
      HALF=0.5*DF
      BLAT=60.     ! STARTING LATITUDE IN DEGREES
            
      DO K=KS,KE+1
        RLAT=BLAT+DF*FLOAT(K-1)   ! STEPPING IN 1DEG
        A1=RLAT*RAD
        A2=(RLAT+HALF)*RAD
        SIZ(K)=SIN(A1)
        SIV(K)=SIN(A2)
        CSZ(K)=COS(A1)
        CSV(K)=COS(A2)
      END DO

      END SUBROUTINE



      SUBROUTINE LEFT_FORCING()
      INTEGER :: LIM, FIM, LIMJ
      REAL :: AM, W

      !  TPF=1000.   ! WAVE PERIOD
   
      W=2*PI/TPF     ! FREQUENCY
      AM=10.         ! AMPLITUDE
  
      DO K=KS,KE
    !   GAM=SQRT(G*H1(JS+1, K))*T/HX
        LIM=M-(KE-K)*3
        IF(LIM .LE. 0)THEN
          SLN1(JS, K)=0.
          GO TO 71
        END IF

        FIM=FLOAT(LIM)
        SLN1(JS, K)=am*sin(w*FIM*T)
     !   STEM=am*sin(w*m*T)
     !   SLO(JS,K)=2*SLN1(JS,K)-UO1(JS+1,K)*SQRT(H1(JS+1,K)/G)
     !   SLN1(JS,K)=  STEM+( (1-GAM)*SLO(JS,K) +GAM*SLO(JS+1,K))
  71    SLO1(JS, K)=SLN1(JS, K)
      END DO  
      END SUBROUTINE




      SUBROUTINE NORTH_FORCING()
      REAL :: AM, W, FIMJ
      INTEGER :: LIMJ

      !TPF=1000.   ! WAVE PERIOD
  
      W=2*PI/TPF   ! FREQUENCY
      AM=10.       ! AMPLITUDE

      DO j=JS,JE
       LIMJ=M-J*2
        IF(LIMJ .LE. 0)THEN
          SLN1(J, KE)=0.
          GO TO 72
        END IF
        FIMJ=FLOAT(LIMJ)

     !  GAM=SQRT(G*H1(JS+1,K))*T/HX
   72   SLN1(J, KE)=am*sin(w*FIMJ*T)
     !  STEM=am*sin(w*m*T)
     !  SLO(JS, K)=2*SLN1(JS, K)-UO1(JS+1, K)*SQRT(H1(JS+1, K)/G)
     !  SLN1(JS, K)=  STEM+( (1-GAM)*SLO(JS, K) +GAM*SLO(JS+1, K))
        SLO1(J, KE)=SLN1(J, KE)
      END DO
      END SUBROUTINE




      SUBROUTINE SOUTH_FORCING()
      REAL :: AM, W

   !  TPF=1000.    ! WAVE PERIOD
   
      W=2*PI/TPF   ! FREQUENCY
      AM=10.       ! AMPLITUDE


      DO j=JS,JE
    !   GAM=SQRT(G*H1(JS+1, K))*T/HX
        SLN1(J, KS)=am*sin(w*m*T)
    !   STEM=am*sin(w*m*T)
    !   SLO1(JS, K)=2*SLN1(JS, K)-UO1(JS+1, K)*SQRT(H1(JS+1, K)/G)
    !   SLN1(JS, K)=  STEM+( (1-GAM)*SLO1(JS, K) +GAM*SLO1(JS+1, K))
        SLO1(J, KS)=SLN1(J, KS)
      END DO
      END SUBROUTINE




      SUBROUTINE RIGHT_FORCING()
      REAL :: AM, W

  !   TP=1500.
  
      W=2*PI/TPF
      AM=100.

      DO K=KS,KE
         SLO1(jE, K)=am*sin(w*m*T)
         SLN1(JE, K)=SLO1(JE, K)
      END DO
      END SUBROUTINE




      SUBROUTINE RIGHT_RADIATING()

      DO K=KS+1,KE-1
        HTOT= H1(JE-1, K)+SLO1(JE-1, K)
        IF(HTOT .LT. 0.) HTOT=0.
        SLO1(JE, K)=UO1(JE, K)*SQRT(HTOT/G)
        SLN1(JE, K)=SLO1(JE, K)
      END DO
      END SUBROUTINE




      SUBROUTINE LEFT_RADIATING()
       
      DO K=KS,KE
        HTOT= H1(JS+1, K)+SLO1(JS+1, K)
        IF (HTOT .LT. 0.)HTOT=0.
        SLO1(JS, K)=-UO1(JS+1, K)*SQRT(HTOT/G)
        SLN1(JS, K)=SLO1(JS, K)
      END DO
      END SUBROUTINE



      SUBROUTINE NORTH_RADIATING()
!Special
      DO j=JS,JE
        HTOT= H1(J, KE)+SLO1(J, KE)
        IF(HTOT .LT. 0.)HTOT=0.
        SLO1(J, KE)=VO1(J, KE-1)*SQRT(HTOT/G)
     !  SLO1(J, KE)=   SLO1(J, KE-1)
        SLN1(J, KE)=SLO1(J, KE)
      END DO
      END SUBROUTINE




      SUBROUTINE SOUTH_RADIATING()

      DO j=JS,JE
        HTOT= H1(J, KS)+SLO1(J, KS)
        IF (HTOT .LT. 0.)HTOT=0.
        SLO1(J, KS)=-VO1(J, KS)*SQRT(HTOT/G)
        SLN1(J, KS)=SLO1(J, KS)
      END DO
      END SUBROUTINE




    ! SUBROUTINE ENERGY_FLUX()
    ! DO J=1,JE
    !   DO K=1,KE
    !
    !     IF (CELL1(J, K) .EQ. 1 .AND. ABS(SLO1(J, K) .GT. 0.5) THEN
    !       if (M(J, K) .LT. 9000)THEN
    !         M(J, K)=M(J, K)+1
    !         ENX(J, K)=ENx(J, K)+(UO1(J, K)+UO1(J+1, K))*0.5*SLO1(J, K)
    !         ENY(J, K)=ENY(J, K)+(VO1(J, K-1)+VO1(J, K)*0.5*SLO1(J, K)
    !       end if
    !
    !     END IF
    !   END DO
    ! END DO

    ! END SUBROUTINE



      SUBROUTINE VELOCITY1X
      REAL, DIMENSION(1:JE, 1:KE) :: DU, UNF
      REAL :: MAG1, UPRX, UPRY, MAG, VAU1, VAU2, VAUN, VAUP, DDU, UON, UOP
 
      DU=0.

!.. West Boundary
      DO K=KS+1,KE
        DU(JS+1, K)=DHU(JS+1, K)+ 0.5*(SLO1(JS, K)+SLO1(JS+1, K)) &
          -0.5*(SLO2(JS, K)+SLO2(JS+1, K))
        UPRX= UO1(JS+1, K)-UO2(JS+1, K)
        IF(DU(JS+1, K) .LE. 5.) DU(JS+1, K)=5.
        UN1(JS+1, K)=UO1(JS+1, K)-GTHX*(SLO1(JS+1, K)-SLO1(JS, K)) /CSZ(K)  &
          -r1*T*UPRX*abs(UPRX)/du(JS+1, K)
      !    UN1(JS+1, K)=0.                                          ! FOR REFLECTIVE CONDITION
      !    UNF(JS+1, K)=UN1(JS+1 ,K)
      END DO

!.. Update UO1
      DO K=KS+1, KE-1
        DO j = JS+2, JE-1
          IF (CELL1(J-1, K) .EQ. 1 .AND. CELL1(J, K) .EQ. 1) THEN
            VAU1=0.25*(VO1(J, K)+VO1(J-1, K)+VO1(J-1, K-1)+VO1(J, K-1))
            VAU2=0.25*(VO2(J, K)+VO2(J-1, K)+VO2(J-1, K-1)+VO2(J, K-1))
            VAUP=0.5*(VAU1+ABS(VAU1))
            VAUN=0.5*(VAU1-ABS(VAU1))
            uprx=UO1(J, K)-UO2(J, K)
            UPRY=VAU1-VAU2
            MAG1= UPRX*UPRX+UPRY*UPRY
            MAG=SQRT(MAG1)
            DU(J, K)=DHU(J, K)+ 0.5*(SLO1(J-1, K)+SLO1(J, K)) &
              - 0.5*(SLO2(J-1,K)+SLO2(J,K))
            DDU=DU(J, K)
            if (DU(J, K) .LE. 2.) DDU=2.   ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION
         !   UO1PM1=0.5*(UO1(j-1,K)+ABS(UO1(j-1,K)))
         !   UONM1=0.5*(UO1(J-1,K)-ABS(UO1(J-1,K)))
            UOP=0.5*(UO1(j, K)+ABS(UO1(j, K)))
            UON=0.5*(UO1(J, K)-ABS(UO1(J, K)))

            UN1(J, K)=UO1(J, K) &
              +FCT*SIZ(K)*VAU1  &
              +NL*T*SIZ(K)*VAU1*UO1(J,K)/(CSZ(K)*R0)                                &
              -THX*(UOP*(UO1(J, K)-UO1(J-1, K))+UON*(UO1(J+1, K)-UO1(J, K)))/CSZ(K) &
              -THY*(VAUP*(UO1(J, K)-UO1(J, K-1))+VAUN*(UO1(J, K+1)-UO1(J, K)))      &
               + GTHX*(SLO1(j-1, K) -SLO1(j, K))/CSZ(K)                             &
              -r1*T*UPRX*MAG/DDU
            IF (Cell2(j, k) .EQ. 0 .AND. Cell2(j-1, k) .EQ. 0) then
              UN1(j, k) = Un1(j, k)-(R-R1)*T*UPRX*MAG/DDU
            END IF

          END IF
        END DO
      END DO

!.. BOUNDARY NORTH IN CASE KE IS RADIATING
      DO j = JS+2, JE-1
        UN1(J, KE)=UN1(J, KE-1)
        UN1(J, KS)=UN1(J, KS+1)
      END DO

! CHECK ON MAY 14 FROM HERE

!.. BOUNDARY CONDITION FOR THE LAST RIGHT POINT
      DO K=KS+1,KE-1
        IF (CELL1(JE-1, K) .EQ. 1 .AND. CELL1(JE, K) .EQ. 1)THEN
          VAU1=0.25*(VO1(JE, K)+VO1(JE-1, K)+VO1(JE-1, K-1)+VO1(JE, K-1))
          VAU2=0.25*(VO2(JE, K)+VO2(JE-1, K)+VO2(JE-1, K-1)+VO2(JE, K-1))
          VAUP=0.5*(VAU1+ABS(VAU1))
          VAUN=0.5*(VAU1-ABS(VAU1))
          uprx=UO1(JE, K)-UO2(JE, K)
          UPRY=VAU1-VAU2
          MAG1= UPRX*UPRX+UPRY*UPRY
          MAG=SQRT(MAG1)
          DU(JE, K)=DHU(JE, K)+0.5*(SLO1(JE-1, K)+SLO1(JE, K)) &
             - 0.5*(SLO2(JE-1, K)+SLO2(JE, K))
          DDU=DU(JE, K)
          if (DU(JE, K) .LE. 5.) DDU=5.
          UOP=0.5*(UO1(jE, K)+ABS(UO1(jE, K)))
          UON=0.5*(UO1(JE, K)-ABS(UO1(JE, K)))
          UN1(JE, K)=UO1(JE, K)+GTHX*(SLO1(JE-1, K)-SLO1(JE, K))/CSZ(K)              &
            +FCT*SIZ(K)*VAU1                                                         &
            +NL*T*SIZ(K)*VAU1*UO1(JE, K)/(CSZ(K)*R0)                                 &
            -THX*(UOP*(UO1(JE, K)-UO1(JE-1, K))+UON*(UO1(JS, K)-UO1(JE, K)))/CSZ(K)  &
            -THY*(VAUP*(UO1(JE, K)-UO1(JE, K-1))+VAUN*(UO1(JE, K+1)-UO1(JE,K)))      &
            -r1*T*UPRX*MAG/DDU
 !           UN1(JE,K)=0.   ! REFLECTIVE BOUNDARY
        END IF
      END DO


     UNF=UN1

!.. FILTER IF NEEDED
      DO K=2,KE
        DO j = JS+2, JE - 1
          UN1(J,K)=UNF(J,K)*(1.-ALPHA)+0.25*ALPHA*(UNF(J-1,K)+2.*UNF(J,K)+UNF(J+1,K))
        END DO
      END DO

!
      DO K=KS+1,KE-1
        DO J=JS+1,JE
          IF (CELL1(J, K) .EQ. 0 .AND. CELL1(j-1, K) .EQ. 0) THEN
            UN1(J, K)=0.
          END IF
        END DO

        DO j = JS+1, JE-1        ! CHANGE 1  TO 2 FOR RADIATION
          IF (CELL1(j, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
            if ((SLO1(j, K) + H1(j+1, K)) .LE. EPSILON) then       ! FOR THE BOUNDARY CONDITION U=0
              UN1(J+1, K)=0.                                       ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL1(J-1, K).EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
            if ((SLO1(j, K) + H1(j-1, K)) .LE. EPSILON) then       ! FOR THE BOUNDARY CONDITION U=0
              UN1(J, K)=0.                                         ! AT THE LEFT WALL
            end if
          END IF
        END DO
      END DO

 GO TO 90

      DO K=KS+1,KE-1
        DO j = JS+1, JE-1        ! CHANGE 1  TO 2 FOR RADIATION
          IF (CELL1(j, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) THEN
            if ((SLO1(j, K) + H1(j+1, K)) .LE. EPSILON) then       ! FOR THE BOUNDARY CONDITION U=0
              if (HTOT .Le. 0) HTOT=10.
              UN1(J+1, K)=  SLO1(J, K)/SQRT(HTOT/G)                ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
            if ((SLO1(j, K) + H1(j-1, K)) .LE. EPSILON) then       ! FOR THE BOUNDARY CONDITION U=0
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 10.) HTOT=10.
              UN1(J, K)= - SLO1(J, K)/SQRT(HTOT/G)                 ! AT THE LEFT WALL
            end if
          END IF
        END DO
      END DO


      DO K=1,KE
        DO j = JS+1, JE-1
          IF (CELL1(J-1, K) .EQ. 1 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) then
            if ((SLO1(J, K) + H1(J+1, K)) .GT. epsilon) then
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 10.) HTOT=10.
              UN1(J+1, K)=  SLO1(J, K)/SQRT(HTOT/G)
     !         UN1(J+1,K)=UN1(J,K)
            end if
          END IF
          IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 1) THEN
            if ((SLO1(J, K) + H1(J-1, K)) .GT. EPSILON) then
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 10.) HTOT=10.
              UN1(J, K)= - SLO1(J, K)/SQRT(HTOT/G)
           !   UN1(J,K)=UN1(J+1,K)
            end if
          END IF

! WET ONLY IN ONE CELL1 SURROUNDED BY DRY CELL1S.
          IF (CELL1(J-1, K) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J+1, K) .EQ. 0) THEN
            HTL= SLO1(J, K)+H1(J-1, K)
            HTR=SLO1(J, K)+H1(J+1, K)
            if (HTL .GT. EPSILON) then
              UN1(J, K)= -SQRT(G*HTL)
            end if
            if ((SLO1(J, K) + H1(J+1, K)) .GT. EPSILON) then
              UN1(J+1, K)=SQRT(G*HTR)
            end if
          END IF
        END DO
      END DO
 90 continue
      END SUBROUTINE



     

      SUBROUTINE VELOCITY2X()
      REAL, DIMENSION(1:JE, 1:KE) :: DU, un2N 
      REAL :: DIST, DDU, uo2P, uo2N, DSLO1, UPRX, UPRY, MAG1, MAG2, MAGD
      REAL :: VAU1, VAU2, VAUN, VAUP
      REAL :: MAGU

      un2=0.
      un2N=0.

!.. ENTIRE DOMAIN
      DO K=KS+1,KE-1
        DO j = JS+1, JE-1
          IF (CELL2(J-1, K) .EQ. 1 .AND. CELL2(J, K) .EQ. 1) then
            DU(J, K)=0.5*(SLO2(J-1, K)+SLO2(J, K))
            DDU=DU(J, K)
            IF (DU(J, K) .LE. 5.) DDU=5. ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION

            uo2P=0.5*(uo2(j, K)+ABS(uo2(j, K)))
            uo2N=0.5*(uo2(J, K)-ABS(uo2(J, K)))
            VAU1=0.25*(VO1(J, K)+VO1(J-1, K)+VO1(J-1, K-1)+VO1(J, K-1))
            VAU2=0.25*(VO2(J, K)+VO2(J-1, K)+VO2(J-1, K-1)+VO2(J, K-1))

            VAUP=0.5*(VAU2+ABS(VAU2))
            VAUN=0.5*(VAU2-ABS(VAU2))

            uprx=UO1(J, K)-UO2(J, K)
            UPRY=VAU1-VAU2
            MAG1= UPRX*UPRX+UPRY*UPRY
            MAG2=UO2(J, K)*UO2(J, K)+VAU2*VAU2

            MAGD=SQRT(MAG1)
            MAGU=SQRT(MAG2)

            DSLO1= SLO1(j-1, K)-SLO1(j, K)

            UN2(J, K)=UO2(J, K)                                                       & 
              +FCT*SIZ(K)*VAU2                                                        &
              +NL*T*SIZ(K)*VAU2*UO2(J, K)/(CSZ(K)*R0)                                 &
              -THX*(UO2P*(UO2(J, K)-UO2(J-1, K))+UO2N*(UO2(J+1 ,K)-UO2(J, K)))/CSZ(K) &
              -THY*(VAUP*(UO2(J, K)-UO2(J, K-1))+VAUN*(UO2(J, K+1)-UO2(J, K)))        &
              + GTHX*DSLO1/CSZ(K)                                                     &
              + GTHXDD*(SLO2(j-1, K) - SLO2(j, K)+H1(J, K)-H1(J-1, K)-DSLO1)/CSZ(K)   &
              +R1*T*UPRX*ABS(MAGD)*RHO1/(RHO2*DDU)                                         &
              -R*T*uo2(j,K)*abs(MAGU)/DDU
          END IF
        END DO
      END DO
 
     DO K=KS+1,KE-1
      DO j = JS+2, JE - 1
         IF (CELL2(J-1, K) .EQ. 0 .AND. CELL2(J, K) .EQ. 0) UN2(J, K)=0.
       END DO
     END DO

!.. extrapolation for the landslide
      DO K=KS+1,KE-1
        DO j = JS+1, JE-1

!. left end of slide 
          IF (CELL2(J-1, K) .EQ. 0 .AND. CELL2(J, K) .EQ. 1 .AND. CELL2(J+1, K) .EQ. 1) then
            UN2(J, K)=UN2(J+1, K)
            LMTEMX(J, K)=LMTEMX(J, K)-T*UN2(J+1, K)
            if (LMTEMX(J, K) .GE. HX*CSZ(K)) then
              CELL2(J-1, K)=1
              SLO2(j-1, K) = 2.*epsilon
              LMTEMX(J, K)=0.
            end if
          ELSE
            LMTEMX(J, K)=0.
          END IF
        END DO
      END DO

      DO K=KS+1,KE-1
        DO j = JE-1, JS+2,-1

!. right end of slide
          IF (CELL2(J-2, K) .EQ. 1 .AND. CELL2(J-1, K) .EQ. 1 .AND. CELL2(J, K) .EQ. 0) then
            UN2(J, K)=UN2(J-1, K)
            LPTEMX(J-1, K)=LPTEMX(J-1, K)+T*UN2(J-1, K)
            if (LPTEMX(J-1, K) .GE. HX*CSZ(K))THEN
              CELL2(J, K)=1
              SLO2(j, K) = 2.*epsilon
              LPTEMX(J-1, K)=0.
            end if
          ELSE
            LPTEMX(J-1, K)=0
          END IF
        END DO
      END DO

!   CHEC   ! FILTER IF NEEDED
      un2n=un2
      DO K=KS+1,KE-1
        DO j = JS+2, JE-1
          IF (CELL2(J-1, K) .EQ. 1 .AND. CELL2(J, K) .EQ. 1 .AND. CELL2(J+1, K) .EQ. 1) then
            un2(J, K)=un2N(J, K)*(1.-ALPHA) &
               +0.25*ALPHA*(un2N(J-1, K)+2.*un2N(J, K)+un2N(J+1, K))
          END IF
        END DO
      END DO

      END SUBROUTINE


      SUBROUTINE CONT1X()
      REAL, DIMENSION(1:JE,1:KE) :: FLUX
      REAL :: SN, SP, ULN, ULP

      FLUX=0.
      SLNN = 0.
      DO K=KS+1,KE-1
        DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
          IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J-1, K) .EQ. 1)THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
            ULP=0.5*(UN1(J, K)+ABS(UN1(J, K)))
            ULN=0.5*(UN1(J, K)-ABS(UN1(J, K)))                      
            SP=SLO1(J-1, K)-SLO2(J-1, K)
            SN=SLO1(J, K)-SLO2(J, K)
            FLUX(J, K)=ULP*SP+ULN*SN+DHU(J, K)*UN1(J, K)
          END IF
        END DO
      END DO

      DO K= KS+1,KE-1
        DO J = JS+1, JE-1
          SLNN(J, K)=SLO1(J ,K)- (FLUX(J+1, K)-FLUX(J, K))*THX/CSZ(K)
        END DO
      END DO
      END SUBROUTINE


  

      SUBROUTINE CONT1Y()
      REAL, DIMENSION(JS:JE,KS:KE) ::  FluxY
      REAL :: SN, SP, VLN, VLP
      INTEGER :: KEE

      FLUXY=0.
      DO J = JS, JE
        DO K=KS,KE-1
    !   DO K=KS,KE    ! SPECIAL BOUNDARY CONDITION

          IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 1)THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
            VLP=0.5*(VN1(J, K)+ABS(VN1(J, K)))
            VLN=0.5*(VN1(J, K)-ABS(VN1(J, K)))

            SP=SLO1(J, K)-SLO2(J, K)
            SN=SLO1(J, K+1)-SLO2(J, K+1)

            FLUXY(J, K)=VLP*SP+VLN*SN+DHV(J, K)*VN1(J, K)
            FLUXY(J, K)=FLUXY(J, K)*CSV(K)

          END IF
        END DO
      END DO

      DO J = JS+1, JE-1
        DO K = KS+1, KE-1
   !    DO K = KS+1, KEE
          SLN1(J, K)=SLNN(J, K)- (FLUXY(J, K)-FLUXY(J, K-1))*THY/CSZ(K) &
             +TRANSX(J,K)+TRANSY(J,K)                                   ! Add in contribution from layer 2 here
        END DO
      END DO
      END SUBROUTINE





      SUBROUTINE CONT2X()
      REAL, DIMENSION(1:JE,1:KE) :: FLUXX
      REAL :: ULP, ULN, DFLUX

      FLUXX = 0.
      SLNN2 = 0.
      TRANSX = 0.
      DO K=KS+1,KE-1
        DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
          IF (CELL2(J, K) .EQ. 1 .AND. CELL2(J-1, K) .EQ. 1) THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
            ULP=0.5*(un2(J, K)+ABS(un2(J, K)))
            ULN=0.5*(un2(J, K)-ABS(un2(J, K)))

            FLUXX(J, K)=  ULP*SLO2(J-1, K)+ULN*SLO2(J, K)
       !    ULP*H1(J-1)+ULN*H1(J) &

          END IF
        END DO
      END DO

      DO K=KS+1,KE-1
        DO J=JS+1,JE-1
          DFLUX=  (FLUXX(J+1, K)-FLUXX(J, K))
          TRANSX(J, K)=  -DFLUX*THX/CSZ(K)
          SLNN2(J, K)=SLO2(J, K)- DFLUX*THX/CSZ(K)
        END DO
      END DO

      END SUBROUTINE




      SUBROUTINE CONT2Y()
      REAL, DIMENSION(1:JE,1:KE) :: FLUXY
      REAL  :: VLP, VLN, DFLUXY

      FLUXY=0.
      TRANSY = 0.

      DO K=KS+1,KE-1
        DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
          IF (CELL2(J, K) .EQ. 1 .AND. CELL2(J, K+1) .EQ. 1) THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
            VLP=0.5*(Vn2(J, K)+ABS(Vn2(J, K)))
            VLN=0.5*(Vn2(J, K)-ABS(Vn2(J, K)))
            FLUXY(J, K)=  VLP*SLO2(J, K)+VLN*SLO2(J, K+1)
       !    ULP*H1(J-1)+ULN*H1(J) &
            FLUXY(J, K)=FLUXY(J, K)*CSV(K)
          END IF
        END DO
      END DO

      DO K=KS+1,KE-1
        DO J=JS+1,JE-1
          DFLUXY=  (FLUXY(J, K)-FLUXY(J, K-1))
          TRANSY(J, K)=  -DFLUXY*THY/CSZ(K)
        END DO
      END DO

      DO J = JS+1, JE-1
        DO K = KS+1, KE-1
          SLN2(J, K)=SLNN2(J, K)- (FLUXY(J, K)-FLUXY(J, K-1))*THY/CSZ(K)
        END DO
      END DO

      END SUBROUTINE




      SUBROUTINE VELOCITY1Y()
      REAL, DIMENSION(1:JE,1:KE) :: DV, VNF
      REAL :: MAG1, VPRY, VPRX, MAG, UAV, UAV1, UAVP, UAVN, UAV2, DDV
      REAL :: VON, VOP

      VN1 = 0.
     
      DV=0.
      DO j = JS, JE
        IF (CELL1(J, KS) .EQ. 1 .AND. CELL1(J, KS+1) .EQ. 1)THEN
          DV(J, KS)=DHV(J, KS) +0.5*(SLO1(J, KS)+SLO1(J, KS+1)) &
             -0.5*(SLO2(J,KS)+SLO2(J,KS+1))
          VPRY= VO1(J, KS)-VO2(J, KS)
          if (DV(J, KS) .LE. 5.) DV(J, KS)=5.
          if (j .LT. JE) then
            UAV=0.25*(UN1(J, KS)+UN1(J+1, KS)+UN1(J+1, KS+1)+UN1(J, KS+1))
          else
            UAV=0.5*(UN1(J, KS)+UN1(J, KS+1))
          end if
          VN1(J, KS)=VO1(J, KS) &
            -FCT*SIV(K)*UAV &
            -NL*T*UAV*UAV*SIV(K)/(CSV(K)*R0) &
            -GTHY*(SLO1(J, KS+1)-SLO1(J, KS))-R1*T*VPRY*abs(VPRY)/dV(J,KS)
        END IF
      END DO

!. just for Js
      DO K=KS+1,KE-1
        IF (CELL1(JS, K) .EQ. 1 .AND. CELL1(JS, K+1) .EQ. 1)THEN
          UAV1=0.25*(UN1(JS, K)+UN1(JS+1, K)+UN1(JS+1, K+1)+UN1(JS, K+1))
          UAVP=0.5*(UAV1+ABS(UAV1)) 
          UAVN=0.5*(UAV1-ABS(UAV1))

          UAV2=0.25*(UN2(JS, K)+UN2(JS+1, K)+UN2(JS+1, K+1)+UN2(JS, K+1))
          vpry=VO1(JS, K)-VO2(JS, K)
          VPRX=UAV1-UAV2

          MAG1= VPRX*VPRX+VPRY*VPRY
          MAG=SQRT(MAG1)
          DV(JS, K)=DHV(JS, K)+0.5*(SLO1(JS, K)+SLO1(JS, K+1)) &
             -0.5*(SLO2(JS, K)+SLO2(JS, K+1))

          DDV=DV(JS ,K)
          IF (DV(JS, K) .LE. 2.) DDV=2.   ! DEFENCE AGAINST ZERO DENOM. IN BOTTOM FRICTION
          VOP=0.5*(VO1(jS, K)+ABS(VO1(jS, K)))
          VON=0.5*(VO1(JS, K)-ABS(VO1(JS, K)))

          VN1(jS, K)=VO1(JS, K) &
             -THY*(VOP*(VO1(JS, K)-VO1(JS, K-1))+VON*(VO1(JS, K+1)-VO1(JS, K))) &
             -THX*UAVN*(VO1(JS+1, K)-VO1(JS, K))/CSV(K) &
             + GTHY*(SLO1(jS, K) - SLO1(jS, K+1)) &
             -FCT*SIV(K)*UAV1  &
             -NL*T*UAV1*UAV1*SIV(K)/(CSV(K)*R0) &
             -R1*T*VPRY*MAG/DDV
        END IF
      END DO


      DO j = JS+1, JE-1
        DO K=KS+1,KE-1
          IF(CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1).EQ.1) THEN
            UAV1=0.25*(UN1(J, K)+UN1(J+1, K)+UN1(J+1, K+1)+UN1(J, K+1))
            UAV2=0.25*(UN2(J, K)+UN2(J+1, K)+UN2(J+1, K+1)+UN2(J, K+1))

            UAVP=0.5*(UAV1+ABS(UAV1))
            UAVN=0.5*(UAV1-ABS(UAV1))

            vpry=VO1(J,K)-VO2(J,K)
            VPRX=UAV1-UAV2

            MAG1= VPRX*VPRX+VPRY*VPRY
            MAG=SQRT(MAG1)

            DV(J, K)=DHV(J, K) +0.5*(SLO1(J, K)+SLO1(J, K+1)) &
               -0.5*(SLO2(J, K)+SLO2(J, K+1))
            DDV=DV(J, K)
            IF (DV(J, K) .LE. 2.) DDV=2.   ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION

            VOP=0.5*(VO1(j, K)+ABS(VO1(j, K)))
            VON=0.5*(VO1(J, K)-ABS(VO1(J, K)))

            VN1(j, K)=VO1(J, K) &
              -THY*(VOP*(VO1(J, K)-VO1(J, K-1))+VON*(VO1(J, K+1)-VO1(J, K))) &
              -THX*(UAVP*(VO1(J, K)-VO1(J-1, K))+UAVN*(VO1(J+1, K)-VO1(J, K)))/CSV(K) &
              + GTHY*(SLO1(j, K) - SLO1(j, K+1)) &
              -FCT*SIV(K)*UAV1  &
              -NL*T*UAV1*UAV1*SIV(K)/(CSV(K)*R0) &
              -R1*T*VPRY*MAG/DDV
            IF (Cell2(j, k) .EQ. 0 .AND. Cell2(j, k+1) .EQ. 0) then
              VN1(j, k) = Vn1(j, k)-(R-R1)*T*VPRY*MAG/DDV
            END IF
          END IF
        END DO
      END DO

vnf = vn1
 
!.. FILTER IF NEEDED
     DO j = JS, JE
       DO K=KS+1,KE-1
         VN1(J,K)=VNF(J,K)*(1.-ALPHA)+0.25*ALPHA*(VNF(J,K-1)+2.*VNF(J,K)+VNF(J,K+1))
      END DO
     END DO


      DO J=JS,JE  ! THIS IS ONLY BEAUTIFICATION
        DO K=KS+1,KE-1
          IF (CELL1(J, K) .EQ. 0 .AND. CELL1(J, K+1) .EQ. 0)THEN
            VN1(J, K)=0.
          END IF
        END DO

        DO K = KS+1, KE-1
          IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
            if ((SLO1(J, K) + H1(J, K+1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION V=0
                                                                ! AT THE RIGHT WALL
              VN1(J, K)=0.
            end if
          END IF

          IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K).EQ.1) THEN
            if ((SLO1(J, K) + H1(J, K-1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION V=0
              VN1(J, K-1)=0.                                    ! AT THE LEFT WALL
            end if
          END IF

        END DO
      END DO

   GO TO 91

      DO J=JS,JE-1
        DO K = KS+1, KE-1
          IF (CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
            if ((SLO1(J, K) + H1(J, K+1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION V=0
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 10.) HTOT=10.  
              VN1(J, K)=SLO1(J, K)/SQRT(HTOT/G)                     ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1) THEN
            if ((SLO1(J, K) + H1(J, K-1)) .LE. EPSILON) THEN        ! FOR THE BOUNDARY CONDITION V=0
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 0) HTOT=10.
              VN1(J, K-1)=-SLO1(J, K)/SQRT(HTOT/G)                  ! AT THE LEFT WALL
            end if
          END IF
        END DO
      END DO

      DO J=1,JE-1
        DO K = KS+1, KE - 1
          IF (CELL1(J, K-1) .EQ. 1 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ. 0) then
            if ((SLO1(J, K) + H1(J, K+1)) .GT. EPSILON) then
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 0) HTOT=10.
              VN1(J, K)=SLO1(J, K)/SQRT(HTOT/G)
          !   VN1(J,K)=VN1(J,K-1)
            end if
          END IF

          IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1).EQ.1) THEN
            if ((SLO1(J, K) + H1(J, K-1)) .GT. EPSILON) then
              HTOT= H1(J, K)+SLO1(J, K)
              if (HTOT .Le. 0) HTOT=10.
              VN1(J, K-1)=-SLO1(J, K)/SQRT(HTOT/G) 
         !    VN1(J, K-1)=VN1(J, K)
            end if
          END IF

!.. stranded wet cells
          IF (CELL1(J, K-1) .EQ. 0 .AND. CELL1(J, K) .EQ. 1 .AND. CELL1(J, K+1) .EQ.0) THEN
            SLD= SLO1(J, K) + H1(J, K-1)
            SLU=SLO1(J, K) + H1(J, K+1)
            if ((SLO1(J, K) + H1(J, K-1)) .GT. EPSILON) then
              VN1(J, K-1)=-SQRT(G*SLD)
            end if
            if ((SLO1(J, K) + H1(J, K+1)) .GT. EPSILON) then
              VN1(J, K)=SQRT(G*SLU)
            end if
          END IF

        END DO
      END DO

91 continue

!.. SPECIAL BOUNDARY CONDITION
!     IF (M .LE. LTIME)THEN
!       DO J=JS,JE
!         VN1(J, KE)=0.
!       END DO
!     END IF

      END SUBROUTINE




      SUBROUTINE VELOCITY2Y()
      REAL, DIMENSION(1:JE,1:KE) :: DV, Vn2N  !, LPTEMY, LMTEMY
      REAL :: DIST, DDV, Vo2P, Vo2N, DSLO1, VPRY, VPRX, MAG1, MAG2, MAGD
      REAL:: MAGU, UAV1, UAV2, UAVP, UAVN
 
!.. entire domain
      DO j=JS+1,JE-1
        DO K=KS+1,KE-1
          IF (CELL2(J, K) .EQ. 1 .AND. CELL2(J, K+1) .EQ. 1) then
            DV(J, K)=0.5*(SLO2(J, K)+SLO2(J, K+1))
            DDV=DV(J, K)
            if (DV(J, K) .LE. 5.) DDV=5.  ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION

            Vo2P=0.5*(Vo2(j, K)+ABS(Vo2(j, K)))
            Vo2N=0.5*(Vo2(J, K)-ABS(Vo2(J, K)))

            UAV1=0.25*(UN1(J, K)+UN1(J+1, K)+UN1(J+1, K+1)+UN1(J, K+1))
            UAV2=0.25*(UN2(J, K)+UN2(J+1, K)+UN2(J+1, K+1)+UN2(J, K+1))
 

            UAVP=0.5*(UAV2+ABS(UAV2))
            UAVN=0.5*(UAV2-ABS(UAV2))

            VprY=VO1(J,K)-VO2(J,K)
            VPRX=UAV1-UAV2
            MAG1= VPRX*VPRX+VPRY*VPRY
            MAG2=VO2(J, K)*VO2(J, K)+UAV2*UAV2

            MAGD=SQRT(MAG1)
            MAGU=SQRT(MAG2)

            DSLO1= SLO1(j, K) - SLO1(j, K+1)

            VN2(j, K)=VO2(J, K)                                                        &
               -THY*(VO2P*(VO2(J, K)-VO2(J, K-1))+VO2N*(VO2(J, K+1)-VO2(J ,K)))        &
               -THX*(UAVP*(VO2(J, K)-VO2(J-1, K))+UAVN*(VO2(J+1, K)-VO2(J, K)))/CSV(K) &
               + GTHY*DSLO1                                                            &
               -FCT*SIV(K)*UAV2                                                        &
               -NL*T*UAV2*UAV2*SIV(K)/(CSV(K)*R0)                                      &
               + GTHYDD*(SLO2(j, K) - SLO2(j, K+1)+H1(J, K+1)-H1(J, K)-dslo1)          &
               +R1*T*VPRY*ABS(MAGD)*RHO1/(RHO2*DDV)                                    &
               -r*T*VO2(J, K)*ABS(MAGU)/DDV
          END IF
        END DO
      END DO

 !.. set zero velocity outside landslide
     DO j=JS+1,JE-1
       DO K=KS+1,KE-1
         IF (CELL2(J, K) .EQ. 0 .AND. CELL2(J, K+1) .EQ. 0) VN2(J, K)=0.   ! Was reversed
        ! IF (CELL2(J, K) .EQ. 0 .AND. CELL2(J, K-1) .EQ. 0) VN2(J, K)=0.
       END DO
     END DO

!.. extrapolation for landslide motion
      DO j = JS+1, JE-1
        DO K=KS+1,KE-1

!. lower end of slide
          IF (CELL2(J, K-1) .EQ. 0 .AND. CELL2(J, K) .EQ. 1 .AND. CELL2(J, K+1) .EQ. 1) THEN
            VN2(J, K-1)=VN2(J, K)
            LMTEMY(J, K)=LMTEMY(J, K) -T*VN2(J, K)
            if (LMTEMY(J, K) .GE. HY) THEN
              CELL2(J, K-1)=1
              SLO2(j, k-1) = 2.*epsilon
              LMTEMY(J, K)=0.
            end if
          ELSE
            LMTEMY(J, K)=0.
          END IF
        END DO
      END DO
 
!. upper end of slide
      DO j=JS, JE
        DO K=KE,KS+2,-1
          IF (CELL2(J, K-2) .EQ. 1 .AND. CELL2(J, K-1) .EQ. 1 .AND. CELL2(J, K) .EQ. 0) then
            VN2(J, K-1)=VN2(J, K-2)
            LPTEMY(J, K-1)=LPTEMY(J, K-1)+VN2(J, K-1)*T 
            if (LPTEMY(J, K-1) .GE. HY) THEN
              CELL2(J, K)=1
              SLO2(j, k) = 2.*epsilon
              LPTEMY(J, K-1)=0.
            end if
          ELSE
            LPTEMY(J, K-1)=0.
          END IF
        END DO
      END DO
 
!. lower left region      
      DO j = JS+1, JE-1
        DO K=KS+1,KE-1
          IF (LMTEMX(j+1, k) .GT. 0. .AND. LMTEMY(j, k+1) .GT. 0. .AND. Cell2(j, k) .EQ. 0) then
            if ((LMTEMX(j+1, k)+LMTEMY(j,K+1)) .GT. Hy) then
            !if (LMTEMX(j, k) .GT. .5*Hx/CSZ(k) .OR. LMTEMY(j,K) .GT. 0.5*Hy) then
              CELL2(J, K)=1
              SLO2(j, k) = 2.*epsilon
              LMTEMY(J, K+1)=0.
              LMTEMX(j+1, K)=0.
            end if
          END IF
        END DO
      END DO

!. upper right region
      DO j = JS+1, JE-1
        DO K=KS+1,KE-1

          IF (LPTEMX(j-1, k) .GT. 0. .AND. LPTEMY(j, k-1) .GT. 0. .AND. Cell2(j, k) .EQ. 0) then
            if ((LPTEMX(j-1, k)+LPTEMY(j,K-1)) .GT. Hy) then
            !if (LMTEMX(j, k) .GT. .5*Hx/CSZ(k) .OR. LMTEMY(j,K) .GT. 0.5*Hy) then
              CELL2(J, K)=1
              SLO2(j, k) = 2.*epsilon
              LPTEMY(J, K-1)=0.
              LPTEMX(j-1, K)=0.
            end if
          END IF
        END DO
      END DO

!. lower right region
      DO j = JS+1, JE-1
        DO K=KS+1,KE-1

          IF (LPTEMX(j-1, k) .GT. 0. .AND. LMTEMY(j, k+1) .GT. 0. .AND. Cell2(j, k) .EQ. 0) then
            if ((LPTEMX(j-1, k)+LMTEMY(j,K+1)) .GT. Hy) then
            !if (LMTEMX(j, k) .GT. .5*Hx/CSZ(k) .OR. LMTEMY(j,K) .GT. 0.5*Hy) then
              CELL2(J, K)=1
              SLO2(j, k) = 2.*epsilon
              LMTEMY(J, K+1)=0.
              LPTEMX(j-1, K)=0.
            end if
          END IF
        END DO
      END DO

!. upper left region
      DO j = JS+1, JE-1
        DO K=KS+1,KE-1

          IF (LMTEMX(j+1, k) .GT. 0. .AND. LPTEMY(j, k-1) .GT. 0. .AND. Cell2(j, k) .EQ. 0) then
            if ((LMTEMX(j+1, k)+LPTEMY(j,K-1)) .GT. Hy) then
            !if (LMTEMX(j, k) .GT. .5*Hx/CSZ(k) .OR. LMTEMY(j,K) .GT. 0.5*Hy) then
              CELL2(J, K)=1
              SLO2(j, k) = 2.*epsilon
              LPTEMY(J, K-1)=0.
              LMTEMX(j+1, K)=0.
            end if
          END IF
        END DO
      END DO
 
!.. FILTER IF NEEDED
      Vn2n=Vn2
      DO K=KS+1,KE-1
        DO j = JS+2, JE-1
          IF (CELL2(J, K-1) .EQ. 1 .AND. CELL2(J, K) .EQ. 1 .AND. CELL2(J, K+1) .EQ. 1) then
            Vn2(J, K)=Vn2N(J, K)*(1.-ALPHA) &
            +0.25*ALPHA*(Vn2N(J, K-1)+2.*Vn2N(J, K)+Vn2N(J, K+1))
          END IF
        END DO
      END DO

      END SUBROUTINE




!.. START HERE MAY 13,2009
      SUBROUTINE WRITER_BEACH
      REAL, DIMENSION(JS:JE, KS:KE) ::  zwrite, uwrite, vwrite, uenf, venf

   !  PRINT *,m,  SLO1(3,1000)
      ZWRITE=-1.

! ================================================================
! SEA LEVEL AVG. FOR EACH MIN. AT STATION, (T=2sec SO 30 TIME STEP)
! ================================================================
      IF(MOD(M, 10) .EQ. 0) THEN
        DO I=1,IS

!         ZSU(I)=SLO1(JMS(I),KMS(I))+ZSU(I)
!         ZSU(I)=ZSU(I)/30.0
          UNITS=100+i
!         ZSU(I)=SLO1(JMS(I),KMS(I))+ZSU(I)
          WRITE(UNITS,*)M, SLO1(JMS(I), KMS(I))


!         ZSU(I)=0.0
        END DO
!     ELSE
!       DO I=1,IS
!        ZSU(I)=SLO1(JMS(I), KMS(I))+ZSU(I)
!       END DO
      END IF
! ================================================================
!     IF(mod(M, 30) .eq. 0)then
!       DO I=1,IS
!         UNITS=100+i
!         WRITE(UNITS,*)SLO1(JMS(I), KMS(I))
!       END DO
!     END IF

      IF (mod(M, 20) .eq. 0)then
          PRINT *,M, 'SLO2(50,100)=',SLO2(50,100)

 !      DO j=JS,Je

 !        write (14,*) UO(J,1500)

 !        write (15,*) SLO1(J,1500)

 !      END DO
 !      DO J=4,JE-3
        DO k=ks,ke
          DO j=js,je
            UENF(J, K)=SLO1(J, K)*UO1(J, K)*H1(J, K)/100.
            VENF(J, K)=SLO1(J, K)*VO1(J, K)*H1(J, K)/100.
            zwrite(j, k)=SLO1(j, k)
            if (CELL1(j, k) .EQ. 0.) zwrite(j, k)=-1.
            uwrite(J, K)=UO1(J, K)
            VWRITE(J, K)=VO1(J, K)
          END DO
        END DO
 !      DO K=31,34
 !	  ZWRITE(30,K)=10.
 !      END DO
 !      ZWRITE(31,32)=10.
 !      DO K=1,KE,4
 !        write (16,*) (zwrite(J, K),J=1,JE,4)
 !        write (16,*) (SLO1(J, K),J=1,JE)
 !        write (17,*) (uwrite(J, K),J=1,JE,4)
 !        write (18,*) (vwrite(J, K),J=1,JE,4)
 !        write (19,*) (uenf(J,K),J=1, JE, 4)
 !        write (20,*) (venf(J, K),J=1, JE, 4)

 !      END DO
 !    END DO
        write (24) ((VO2(J, K),J=1, JE, 4),K=1, KE, 4)
        write (23) ((UO2(J, K),J=1, JE, 4),K=1, KE, 4)
        write (22) ((SLO2(J, K),J=1, JE, 4),K=1, KE,4)
        write (20) ((venf(J, K),J=1, JE, 4),K=1, KE, 4)
        write (19) ((uenf(J, K),J=1, JE, 4),K=1, KE, 4)
        write (18) ((vwrite(J, K),J=1, JE, 4),K=1, KE, 4)
        write (17) ((uwrite(J, K),J=1, JE, 4),K=1, KE, 4)
        write (16) ((zwrite(J, K),J=1, JE, 4),K=1, KE, 4)
      END IF
      END subroutine



      SUBROUTINE WRITER_MAX
      open(unit=21,file='ampmax.dat',form='unformatted',status='unknown')
    ! open(unit=21,file='ampmax.dat',status='unknown')

       DO J=JS,JE
         DO K=KS,KE
           IF (CELL1(j, k) .eq. 0)ZMAX(j, k)=-1
         END DO
       END DO

       write (21) ((ZMAX(J, K),J=1, JE, 2),K=1, KE ,2)
       close(21)
       END subroutine


  END  program SLOSH
