!     Last change:  ZK   24 Sep 2018    6:18 pm
      PROGRAM RUNUP
    !.. program originated by Z.K. at Univ. of Alaska
!.. !.. tested and and changed by W.K.
!..
!.. INTRODUCING A NEW VARIABLE - THE BOTTOM DISPLACEMENT-  eto AND etn

      INCLUDE "block_slide.f90"


!       Note -- all units are in CGS (Set density = 1)
!         --  +  --  + --  +      SPACE LOCATION OF SEA LEVEL AND VELOCITY
!         U   Z  U   Z  U  Z
!          J-1     J    J+1       GRID ENUMERATION

      CHARACTER*16 argm
      REAL    ::  HTOT

!.. intializations
      M=0
      Cell = 0
      Flux = 0.0
      SLMI=1000.
      SLMA=0.
      UO=0.; UN=0.; SLO=0.; SLN=0.; D=0.
      H=0.; ETO=0.; ETN=0.
      JQ = 0

!.. Create bathymetry
      CALL BEACH1()

      DO M=1, ME     !TIME LOOP
        IF (MOD(M, 100) .EQ. 0) print*, 100.*float(M)/float(ME), " percent done"

      !---------------------boundary-------------------
!   LEFT BOUNDARY CONDITION IS FORCING WHEN AT THE LEFT
!    SIDE THE SEA LEVEL IS GIVEN:

        CALL LEFT_radiating()
        CALL RIGHT_RADIATING()

 !      SLN(JS)=SLO(JS)

!.. ESTABLISH WET-DRY STATUS
        DO j=js,je
          D(j)=h(j)+SLO(j)-ETO(J)
          IF(D(J) .LT. EPSILON) THEN
            SLO(J)=-H(J)+ETO(J)
            CELL(J)=0
          ELSE IF (D(J) .GE. EPSILON) THEN
            CELL(J)=1
          END IF
        END DO


!THIS IS ACTUALLY RUNUP
!GO TO 21
        DO j = JS+1, JE-1
          IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then      ! detect dry cell to the right
            if ((SLO(j) + h(j+1)-ETO(J+1)) .GT. EPSILON) then 
              D(J+1)= SLO(j) + h(j+1)-ETO(J+1)
              Cell(j+1) = 1
 !             SLO(J+1) = SLO(j)
              if (CELL(J-1) .EQ. 1) THEN
                UO(J+1)=UO(J)
              end if
              if (CELL(J-1) .EQ. 0) THEN                      ! CELL(J) SURROUNDED BY DRY CELLS
                UO(J+1)=SQRT(G*D(J+1)) 
              end if
            end if
          END IF

          IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN     ! detect dry cell to the left
            if ((SLO(J) + H(J-1)-ETO(J-1)) .GT. EPSILON) then
              D(J-1)= SLO(J) + H(J-1)-ETO(J-1)
              CELL(J-1) = 1
   !          SLO(J-1) = SLO(J)        
              if (CELL(J+1) .EQ. 1 )THEN
                UO(J)=UO(J+1)
              end if
              if (CELL(J+1) .EQ. 0) THEN                         !CELL(J) SURROUNDED BY DRY CELLS
                UO(J)=-SQRT(G*D(J-1)) !BY DRY CELLS
              end if
            end if
          END IF
        END DO
!GO TO 89
        ! SETTING VELOCITY ALONG X

        DO J=JS+1,JE-1
          IF (CELL(J) .EQ. 0 .AND. Cell(j-1) .EQ. 0)THEN
            UO(J)=0.
          END IF
        END DO

        DO j = JS+1, JE-1        ! CHANGE 1  TO 2 FOR RADIATION
          IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then
            if ((SLO(j) + h(j+1)-ETO(J+1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              UO(J+1)=0.                       ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
            if ((SLO(j) + h(j-1)-ETO(J-1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              UO(J)=0.                      ! AT THE LEFT WALL
            end if
          END IF
        END DO

GO TO 89

        DO j = JS+1, JE-1
          IF (Cell(j) .EQ. 1 .AND.CELL(J+1) .EQ. 0) then
            if ((SLO(j) + h(j+1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              HTOT= H(J)+SLO(J)
              if (HTOT .Le. 0.) HTOT=10.
              UO(J+1)=  SLO(J)/SQRT(HTOT/G)                     ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
            if ((SLO(j) + h(j-1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              HTOT= H(J)+SLO(J)
              if (HTOT .Le. 0.) HTOT=10.
              UO(J)= - SLO(J)/SQRT(HTOT/G)
                                     ! AT THE LEFT WALL
            end if
          END IF
        END DO

   89 CONTINUE

   21 CONTINUE

!.. JUST FOR QUICK ORIENTATION
        DO j=JS+1,je-1
          IF (SLO(J) .GT. SLMA) THEN
            SLMA=SLO(J)
          END IF
          IF (SLO(J) .LT. SLMI) THEN
            SLMI=SLO(J)
          END IF
        END DO


!   NOTE, THERE IS ONLY ONE SUBROUTINE FOR VELOCITY, BUT FOR BEACH4 IT HAS TO BE MODIFIED
!   FOR RADIATION AT RIGHT END OFFSET DOMAIN

!.. update velocity
        CALL VELOCITY()

!       ETN=0.
        CALL BOTTOM_DEF()
!       IF(M .EQ. 1)THEN    !This is because initial value is not zero
!         ETO=ETN
!       END IF


!.       >>>Update    SLO   first<<<

!.. update sea level through continuity eqn.
        CALL CONT()

!.. change variables - advance to next time step
        SLO=SLN
        UO=UN  
        ETO=ETN

        CALL WRITER_BEACH()

      END DO                          ! END TIME LOOP


      PRINT*,'SLMAX=',SLMA,'SLMIN=',SLMI
 

    CONTAINS

 

!.. bathymetry
      SUBROUTINE BEACH1()  ! SLOPING SHORE LINE

      H=300000.            ! CONSTANT BOTTOM DEPTH - free wave speed much greater than slide block speed
    
     ! H=7000.             !  Set H so that the free wave speed is ~10% greater than the slide block speed
     ! H=4000.             !  Set H so that the free wave speed is only ~80% of the slide block speed


     ! DO j=js,150000
     ! h(j)=h(j)
     ! end do

      DO j=js+1,je
        DHU(j)=(H(j-1)+H(J))*0.5
      END DO                ! DEPTH AT THE U POINTS
      DHU(JS)=DHU(JS+1)

      END SUBROUTINE
 


!.. BOUNDARY CONDITIONS
      SUBROUTINE LEFT_FORCING()
      REAL    :: W, AM, DJS1

      W=2.*PI/TP
      AM=200.
      DJS1=H(JS+1)+SLO(JS)                                !
      SLO(js)=am*sin(w*m*T) &
        -UO(JS+1)*SQRT(DJS1/G)
  !   SLO(JS)=SLO(JS)+(UO(JS+1)-UNR)*SQRT(h(JS+1)/G)
      SLN(JS)=SLO(JS)

      END SUBROUTINE




      SUBROUTINE RIGHT_FORCING()
      REAL    :: W, AM

      W=2.*PI/TP
      AM=100.

      SLO(jE)=am*sin(w*m*T) &
         -uO(JE)*SQRT(h(JE)/g)
      SLN(JE)=SLO(JE)

      END SUBROUTINE




      SUBROUTINE LEFT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H(js+1) +SLO(js+1)
      IF(Dtmp .LT. 0.) Dtmp = 0.
      SLO(js) = -uo(js+1)*SQRT(Dtmp/g)
      SLN(js) = SLO(js)

      END SUBROUTINE




      SUBROUTINE RIGHT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H(JE-1) +SLO(JE-1)
      IF( Dtmp .LT. 0. ) Dtmp = 0.
      SLO(JE)=UO(JE)*SQRT(DTMP/G)
      SLN(JE)=SLO(JE)

      END SUBROUTINE




      SUBROUTINE BOTTOM_DEF()
      INTEGER:: MG,JSG

!  HORIZONTAL DEFORMATION SPEED IS 25 M/S, THEREFORE 10M GRID INCREMENTS
!  ARE TRAVELLED IN 0.4S, I.E. IN 40 TIME STEPS. THEREFORE EVERY 40
!  TIME STEPS, A NEW BOTTOM GRID IS INTRODUCED INTO MOVEMENT
!  starting from middle domain jg (given in the block_slide)

      IF(MOD(M, 40) .EQ. 0) THEN
        JQ=JQ+1                ! INDEX TO BE ADDED TO JG WHICH IS HALF OF THE ENTIRE DOMAIN
        MG=0                   ! INDEX TO RUN FROM 1 TO 40 (but here only 3)
        JSG=JG+JQ-1
      END IF
      MG=MG+1                  ! EVERY TIME STEP +1 UP TO 40

      IF (MG .GT. MGEN) then
        ETN(jsg) = 200.
      ELSE
        ETN(JSG)=200.*FLOAT(MG)/FLOAT(MGEN)  ! LINEAR CHANGE IN TIME
      END IF
      
      IF (JG .LE. (jsg-1)) ETN(JG:jsg-1) = 200.
 
      END SUBROUTINE


 
!.. ACTUAL EQUATIONS OF CONTINUITY
      SUBROUTINE CONT()
      REAL, DIMENSION(1:JE) :: FLUX
      REAL :: ULP, ULN

      FLUX=0.
    !  CELL(JS)=1
    !  CELL(JS+1)=1
      DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
        IF (CELL(J) .EQ. 1 .AND. CELL(J-1) .EQ.1 ) THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
          ULP=0.5*(UN(J)+ABS(UN(J)))
          ULN=0.5*(UN(J)-ABS(UN(J)))
          FLUX(J)=ULP*SLO(J-1)+ULN*SLO(J)+DHU(J)*UN(J) &
            - ULP*ETO(J-1)-ULN*ETO(J)
        END IF
      END DO

      DO J = JS+1, JE-1
        SLN(J)=SLO(J)- (FLUX(J+1)-FLUX(J))*THX + &
            ETN(J)-ETO(J)
      END DO

      END SUBROUTINE





      SUBROUTINE VELOCITY()
      REAL, DIMENSION(1:JE) :: DU, UNN
      REAL, PARAMETER :: ALPHA =0.02
      REAL :: DIST, DDU, UOP, UON

      UNN=0

!.. LEFT BOUNDARY
      DU(JS+1)=DHU(JS+1)+0.5*(SLO(JS)+SLO(JS+1))
      IF(DU(JS+1) .LE. 5.) DU(JS+1)=5.
      UN(JS+1)=UO(JS+1)-GTHX*(SLO(JS+1)-SLO(JS))-r*T*UO(JS+1)*abs(UO(JS+1))/du(JS+1)
      unn(js+1)=UN(JS+1)

!.. ENTIRE DOMAIN
      DO j = JS+2, JE-1
        DU(J)=DHU(J)+0.5*(SLO(J-1)+SLO(J))
        DDU=DU(J)
        IF(DU(J) .LE. 5.) DDU=5.   ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION
        UOP=0.5*(UO(j)+ABS(UO(j)))
        UON=0.5*(UO(J)-ABS(UO(J)))
        Un(j)=UO(J)-THX*(UOP*(UO(J)-UO(J-1))+UON*(UO(J+1)-UO(J))) &
          + GTHX*(SLO(j-1) - SLO(j)) &
          -r*T*UO(j)*abs(UO(j))/DDU
      END DO

!.. BOUNDARY CONDITION FOR THE LAST RIGHT POINT
      UN(JE)=UO(JE)-GTHX*(SLO(JE)-SLO(JE-1)) &
         -r*T*UO(JE)*abs(UO(JE))/du(JE-1)

      UNN=UN  ! JUST FOR FILTERING


!.. CHECK  ! FILTER IF NEEDED

      DO j = JS+2, JE-1
        uN(J)=UNN(J)*(1.-ALPHA)+0.25*ALPHA*(UNN(J-1)+2.*UNN(J)+UNN(J+1))
      END DO
                                                                          
      DO J=JS+2,JE-1  ! THIS IS ONLY BEAUTIFICATION (but good one)
        IF (Cell(j) .EQ. 0 .AND. Cell(j-1) .EQ. 0) THEN
          UN(J)=0.
       !  IF((D(J-1)+D(J)) .LE. 0.) UN(J)=0.
        END IF
      END DO


      DO j = JS+1, JE-1
        IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then
          if ((SLO(j) + h(j+1)) .LE. 0.) THEN     ! FOR THE BOUNDARY CONDITION U=0
            UN(J+1)=0.                            ! AT THE RIGHT WALL
          end if
        END IF

        IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
          if ((SLO(j) + h(j-1)) .LE. 0.) THEN     ! FOR THE BOUNDARY CONDITION U=0
            UN(J)=0.                              ! AT THE LEFT WALL
          end if
        END IF
      END DO

      END SUBROUTINE

 


      Subroutine WRITER_BEACH()

      open(unit=15,file='LEVEL.dat',status='unknown')
      open(unit=16,file='VELOCITY.dat',status='unknown')
      open(unit=17,file='level_fine.dat',status='unknown')

 ! IF(M==MGEN)THEN
 !   DO j=JS,Je,100
 !   write (15,*) SLO(J)
 !   END DO
 !   END IF


      IF (mod(m,500) .eq. 0)then
        PRINT*,M,slo(150001),slo(150002)
      END IF
      IF (mod(m,500).eq.0)then
        DO j=JS,Je,100
          write (15,*) SLO(J)
          write (16,*) UO(J)
        END DO

      END IF
      IF (m .EQ. 250000) THEN
        DO j=150000,165000
          write (17,*) SLO(J)
        END DO
      END if
   !   close(15)
   !   close(16)
   !   close(17)
      END subroutine

   END PROGRAM   RUNUP
